/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Nightly Tester Tools.
 *
 * The Initial Developer of the Original Code is
 *      Dave Townsend <dave.townsend@blueprintit.co.uk>.
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK *****
 *
 * $HeadURL: file:///srv/svn/repos/dave/mozilla/firefox/buildid/branches/1.0/src/chrome/content/extensions/extensions.js $
 * $LastChangedBy: dave $
 * $Date: 2006-04-27 21:33:16 +0100 (Thu, 27 Apr 2006) $
 * $Revision: 658 $
 *
 */

var myExtensionAppEnabler = {

addInArray: function(menus,item,before,after)
{
	var temp = [];
	var shift=0;
	var added=false;
	for (var i = 0; i < menus.length; i++)
	{
		if (menus[i]==before)
		{
			temp[i+shift]=item;
			added=true;
			shift++;
		}
		temp[i+shift]=menus[i];
		if (menus[i]==after)
		{
			shift++;
			temp[i+shift]=item;
			added=true;
		}
	}
	if (!added)
	{
		temp[i+shift]=item;
	}
	return temp;
},

init: function()
{
  // if (typeof showView == "function") { // addons window itself
  	gAddonContextMenus=myExtensionAppEnabler.addInArray(gAddonContextMenus,"menuitem_appenable","menuitem_enable",null);
  	gUpdateContextMenus=myExtensionAppEnabler.addInArray(gUpdateContextMenus,"menuitem_appenable",null,"menuitem_includeUpdate");
  // } else {
  	// gExtensionContextMenus=myExtensionAppEnabler.addInArray(gExtensionContextMenus,"menuitem_appenable","menuseparator_2",null);
  	// gThemeContextMenus=myExtensionAppEnabler.addInArray(gThemeContextMenus,"menuitem_appenable",null,"menuitem_enable");
  // }
},

load: function()
{
/*	var prefservice = Components.classes['@mozilla.org/preferences-service;1']
							.getService(Components.interfaces.nsIPrefService);
	var prefs = prefservice.getBranch("nightly.").QueryInterface(Components.interfaces.nsIPrefBranchInternal);
  
	var enableb = document.getElementById("enableallButton");
	enableb.setAttribute("hidden",!prefs.getBoolPref("showEnableAll"));
*/	
	var context = document.getElementById("addonContextMenu");
	if (!context)
	  context = document.getElementById("extensionContextMenu");
	context.addEventListener("popupshowing",myExtensionAppEnabler.popupShowing,false);
},

isCompatible: function(id)
{
	var em = Components.classes["@mozilla.org/extensions/manager;1"]
							.getService(Components.interfaces.nsIExtensionManager);
  var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
  											.getService(Components.interfaces.nsIRDFService);
	var vc = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                               .getService(Components.interfaces.nsIVersionComparator);
  
  var ds = em.datasource;
  var extension = rdfService.GetResource(id);
  var compatprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#compatible");
  var compatible = ds.GetTarget(extension,compatprop,true);
  if (compatible)
  {
    compatible=compatible.QueryInterface(Components.interfaces.nsIRDFLiteral)
	  return (compatible.Value=="true");
  }
  return true;
},

isUsable: function(id)
{
	return true;
},

makeCompatible: function(id,app,version)
{
	var em = Components.classes["@mozilla.org/extensions/manager;1"]
							.getService(Components.interfaces.nsIExtensionManager);
  var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
  											.getService(Components.interfaces.nsIRDFService);
	var changed=false;
	var idprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#id");
	var targappprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#targetApplication");
	var minprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#minVersion");
	var maxprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#maxVersion");
	var appdisprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#appDisabled");
	var userdisprop = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#userDisabled");

	var vc = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                               .getService(Components.interfaces.nsIVersionComparator);
	var ds = em.datasource;
	var extension = rdfService.GetResource(id);
	var targets = ds.GetTargets(extension,targappprop,true);
	while (targets.hasMoreElements())
	{
		var targapp = targets.getNext();
		var targid = ds.GetTarget(targapp,idprop,true).QueryInterface(Components.interfaces.nsIRDFLiteral);
		if (targid.Value==app)
		{
  		var targmin = ds.GetTarget(targapp,minprop,true).QueryInterface(Components.interfaces.nsIRDFLiteral);
  		if (vc.compare(version,targmin.Value)<0)
  		{
	  		var newtargmin = rdfService.GetLiteral(version);
	  		ds.Change(targapp,minprop,targmin,newtargmin);
	  		changed=true;
	  	}
  		var targmax = ds.GetTarget(targapp,maxprop,true).QueryInterface(Components.interfaces.nsIRDFLiteral);
  		if (vc.compare(version,targmax.Value)>0)
  		{
	  		var newtargmax = rdfService.GetLiteral(version);
	  		ds.Change(targapp,maxprop,targmax,newtargmax);
	  		changed=true;
	  	}
  	}
	}
	if (changed)
	{
		var target = ds.GetTarget(extension, appdisprop, true);
		if (target)
			ds.Unassert(extension, appdisprop, target);
		target = ds.GetTarget(extension, userdisprop, true);
		var newtarget = rdfService.GetLiteral("true");
		if (target)
			ds.Change(extension, userdisprop, target, newtarget);
		else
			ds.Assert(extension, userdisprop, newtarget, true);
    ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    ds.Flush();
		em.enableItem(getIDFromResourceURI(id));
	}
	return changed;
},

popupShowing: function(event)
{
	var item = gExtensionsView.selectedItem;
	var menu = document.getElementById("menuitem_appenable");
	var menuclone = document.getElementById("menuitem_appenable_clone");

	if (item && (gView == "extensions" || gView == "themes")) {
    menu.hidden=myExtensionAppEnabler.isCompatible(item.id);
	} else {
    menu.hidden=true;
	}

	if (menuclone)
		menuclone.hidden=menu.hidden;		
  return true;
},

confirmChange: function()
{
	var prefservice = Components.classes['@mozilla.org/preferences-service;1']
						.getService(Components.interfaces.nsIPrefBranch);

	if (prefservice.getBoolPref("nightly.showExtensionConfirm"))
	{
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);
	    
    var checkResult = { };
    
    var bundle = document.getElementById("nightlylocale");
    
    if (promptService.confirmCheck(window,bundle.getString("nightly.confirm.title"),
    	bundle.getString("nightly.confirm.description"),
    	bundle.getString("nightly.confirm.checkbox"),
  		checkResult))
		{
		  prefservice.setBoolPref("nightly.showExtensionConfirm",!checkResult.value);
			return true;
		}
		else
		{
			return false;
		}	  	
	}
	else
	{
		return true;
	}
},

appEnable: function()
{
	if (myExtensionAppEnabler.confirmChange())
	{
    var ev = gExtensionsView;
		var appinfo = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo);
		var item = ev.selectedItem;
		var prefservice = Components.classes['@mozilla.org/preferences-service;1']
							.getService(Components.interfaces.nsIPrefBranch);
		
		var version = appinfo.version;
		try
		{
			version=prefservice.getCharPref("app.extensions.version");
			if (!version)
				version=appinfo.version;
		}
		catch (e) { }
		
		if (myExtensionAppEnabler.makeCompatible(item.id,appinfo.ID,version))
		{
			ev.selectedItem = document.getElementById(item.id);
		}
	}
},

enableAll: function()
{
	var appinfo = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo);
	var prefservice = Components.classes['@mozilla.org/preferences-service;1']
						.getService(Components.interfaces.nsIPrefBranch);
	
	var version = appinfo.version;
	try
	{
		version=prefservice.getCharPref("app.extensions.version");
		if (!version)
			version=appinfo.version;
	}
	catch (e) { }
	
	var confirmed=false;
	
  var ev = gExtensionsView;
  var count = ev.getRowCount();
  for (var i=0; i<count; i++)
  {
    var item = ev.getItemAtIndex(i);
    dump(item.id+"\n");
    if (!myExtensionAppEnabler.isCompatible(item.id))
    {
      if (!confirmed)
      {
        confirmed=myExtensionAppEnabler.confirmChange();
        if (!confirmed)
          return;
      }
      myExtensionAppEnabler.makeCompatible(item.id,appinfo.ID,version);
    }
  }
 	var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"]
									.getService(Components.interfaces.nsIStringBundleService);
	var bundle = sbs.createBundle("chrome://local_install/locale/nightly.properties");
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);
  var text;
  if (!confirmed)
  {
    text=bundle.GetStringFromName("nightly.noincompatible.message");
  }
  else
  {
    text=bundle.GetStringFromName("nightly.madecompatible.message");
  }
  promptService.alert(null,"MR Tech Toolkit",text);
}

}

if (!local_common.IsOldBrowser()) {
  myExtensionAppEnabler.init();
  
  window.addEventListener("load",myExtensionAppEnabler.load,false);
}

function openURL(aURL) {
  local_common.openURL(aURL, true, true);
}

function overrideShowView() {
  // var viewGroup = document.getElementById("viewGroup");
  // viewGroup.setAttribute("last-selected", nsPreferences.copyUnicharPref('local_install.addons_view_override'));

  var viewGroup = document.getElementById("viewGroup");
  var thisGroup = nsPreferences.copyUnicharPref('local_install.addons_view_override')

  if (thisGroup == "installs" || thisGroup == "updates") {
    // window.addEventListener("unload", function() {
      // nsPreferences.setUnicharPref("local_install.addons_view_override", "extensions")
    // }, false );
  } else {
    viewGroup.setAttribute("last-selected", thisGroup);
  }

  
}

var myAddonsViewSwitcher = {

  _branch: null,

  register: function() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    myAddonsViewSwitcher._branch = prefService.getBranch("local_install.addons_view_override");
    var pbi = myAddonsViewSwitcher._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    pbi.addObserver("", myAddonsViewSwitcher, false);

  },

  unregister: function() {
    if(!myAddonsViewSwitcher._branch) return;

    var pbi = myAddonsViewSwitcher._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    pbi.removeObserver("", myAddonsViewSwitcher);
  },

  observe: function(aSubject, aTopic, aData) {
    if (aTopic != "nsPref:changed") return;

    try {
      showView(nsPreferences.copyUnicharPref('local_install.addons_view_override'));
    } catch (ex) {
    }  
  }
}

var sabid = {
  init: function() {

    if (!nsPreferences.getBoolPref("local_install.toggleAddonFilterField") && 
        !nsPreferences.getBoolPref("local_install.toggleAddonSortButton")) {
      return;
    }

    var Container = document.createElement('hbox');
    Container.setAttribute("id", "addonsCustomContainer");

    if (nsPreferences.getBoolPref("local_install.toggleAddonFilterField")) {
      var SearchTextBox = document.createElement('textbox');
      SearchTextBox.setAttribute('id', 'addons-filter');
      SearchTextBox.setAttribute('type', 'timed');
      SearchTextBox.setAttribute('timeout', '500');
      SearchTextBox.setAttribute('oncommand', 'sabid.filter();');
      SearchTextBox.setAttribute('style', '-moz-appearance: none;');
      SearchTextBox.setAttribute('flex', '1');
      Container.appendChild(SearchTextBox);
    }

    if (nsPreferences.getBoolPref("local_install.toggleAddonSortButton")) {
      var SortButton = document.createElement('button');
      var bundle = document.getElementById("nightlylocale");
      SortButton.setAttribute('id', 'addons-sort-button');
      SortButton.setAttribute('oncommand', 'sabid.sort();');
      SortButton.setAttribute('tooltiptext', bundle.getString("nightly.sortbutton.tooltip"));      
      Container.appendChild(SortButton);
    }
    
    document.getElementById('commandBarBottom').appendChild(Container);
    
    if (nsPreferences.getBoolPref("local_install.toggleAddonFilterField")) {
      document.getElementById('addons-filter').focus();
    }
  },
  
  getInstallationDate: function(addonID) {
    
    if (!addonID) {
      addonID = gExtensionsView.selectedItem.id;
    }

    var ____rdfs = Components.classes["@mozilla.org/rdf/rdf-service;1"]
      .getService(Components.interfaces.nsIRDFService);
    var date = null;
    var ds = gExtensionManager.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    var res = ____rdfs.GetResource(addonID);
    var installDateArc = ____rdfs.GetResource(PREFIX_NS_EM + "installDate");
    var installDate = ds.GetTarget(res, installDateArc, true);
    if (installDate && installDate instanceof Components.interfaces.nsIRDFDate)
      return installDate.Value;
    else
      return new Date();
  },

  sort: function() {
    var ExtensionsView = document.getElementById('extensionsView');
    var sortButton = document.getElementById('addons-sort-button');
    
    var numExt = ExtensionsView.childNodes.length;

    if (numExt > 1) {
      var arrayExt = new Array();
      var allreadyMovedExt = 0;

      for (var a = 1; a < numExt; a++)
        arrayExt.push(sabid.getInstallationDate(ExtensionsView.childNodes[a].id));
    //sort
      
      if (!sortButton.hasAttribute("sorted")) {
        arrayExt = arrayExt.sort();
        sortButton.setAttribute("sorted", "true")
      } else {
        arrayExt = arrayExt.sort().reverse();
        sortButton.removeAttribute("sorted")
      }
      
      for (var id in arrayExt) {
        for (var a = 1; a < numExt - allreadyMovedExt; a++) {
          if (arrayExt[id] == sabid.getInstallationDate(ExtensionsView.childNodes[a].id)) {
            ExtensionsView.appendChild(ExtensionsView.childNodes[a]);
            allreadyMovedExt++;
          }
        }
      }

      gExtensionsView.selectedItem = gExtensionsView.children[0];
    }
  },

  filter: function() {
    var ExtensionsView = document.getElementById('extensionsView');
    numExt = ExtensionsView.childNodes.length;
  
    var search  = document.getElementById('addons-filter').value.toLowerCase();
    if (numExt > 1) {
      var results=false;
      for( var a = 1; a < numExt; a++) {
        if (ExtensionsView.childNodes[a].label.toLowerCase().indexOf(search) != -1) {
          ExtensionsView.childNodes[a].removeAttribute('hidden');
          results = true;
        } else {
          ExtensionsView.childNodes[a].setAttribute('hidden', "true");
          ExtensionsView.childNodes[a].setAttribute('disabled', "true");
        }
      }
      if (results) {
        document.getElementById('addons-filter').style.color = "black !important";
        document.getElementById('addons-filter').style.backgroundColor = "white !important";
      }	else {
        document.getElementById('addons-filter').style.color = "white !important";
        document.getElementById('addons-filter').style.backgroundColor = "#FF6666 !important";
      }
    }
  }
}

var myAddonsFunctions = {
  
  init: function() {
    if (typeof onExtensionUpdateNow == "function") {
      var oldExtensionUpdateNow = onExtensionUpdateNow
      onExtensionUpdateNow = Local_Install.myExtensionUpdateNow
    }

    if (nsPreferences.getBoolPref('local_install.showCustomUpdateThrobber')) {
      Local_Install.showCustomUpdateThrobber();
    }
    
    myAddonsViewSwitcher.register();
    
    Local_Install.toggleMenuIcons();
    
    sabid.init();
    
    setTimeout(Local_Install.setWindowTitle, 250);
    
  }

}

window.addEventListener('load', function() {Local_Install.popupload();}, true);
window.addEventListener("load", myAddonsFunctions.init, false);

window.addEventListener("unload", myAddonsViewSwitcher.unregister, false);

