/* local_install.js */

var BASE_EXTENSION_DIR = "local_install.base_extension_dir";
var BASE_THEME_DIR = "local_install.base_theme_dir";
var list = [];
var disabledlist = [];
var myDownloadManager = null;
var myExtensionManager = null;
var myObserverIndex = null;
var defaultTheme = null;
var prefBranch_themeChanged = null;
var prefBranch_LocalInstall = null;
var prefBranch_throbber = null;
var myUpdaterTitle = "";
var myObserverStack = []

var Local_Install = {

  gBaseExtensionDir: null,
  gBaseThemeDir: null,
  isMyConfigInWindow: true,
  liStartup: true,

  disableExtensions: function() {

    if (nsPreferences.getBoolPref("local_install.promptingToAutoUninstall")) {
      return;
    } else {
      nsPreferences.setBoolPref("local_install.promptingToAutoUninstall", true);
    }

    if (nsPreferences.getBoolPref("local_install.disableAutoUninstall")) {
      return;
    }

    list = [];
    var items = [];
    var warning_list = []
    var outStr = "";
    var guid_list = {};
    
    guid_list['{0069127F-F91E-4A3A-829A-9CAB9D259E94}'] = true; // about:about
    guid_list['{0F25ED9F-9213-422D-9AB9-7DA9BD416FFA}'] = true; // disable xpi delay
    guid_list['{14AFCCF3-39B5-437f-9839-BE3D054A56B4}'] = true; // Slim Extension List
    guid_list['{19c11468-3228-440b-9442-b42c38f16a65}'] = true; // Browse Extension (Folder)
    guid_list['{1d1bf47b-eb43-4fd8-a49a-efb6ba833d29}'] = true; // Simple Options Button
    guid_list['{1d4b3436-8904-4977-9701-5961211d253a}'] = true; // show failed url
    guid_list['{222311C6-B222-4aa2-90BF-60CC49222242}'] = true; // ListZilla
    guid_list['{5b70ba17-0bf0-4608-8323-7c83ed8c54e9}'] = true; // Install New Theme
    guid_list['{5FFFEEE3-027F-4f48-B0FE-253145010F0C}'] = true; // close all
    guid_list['{65f3d609-18c1-4f62-bcef-1973b6abeab4}'] = true; // restart firefox
    guid_list['{9DE10981-4C40-4b0e-949F-D720243B5BF0}'] = true; // EmButtons
    guid_list['{a756d17a-5a4c-4417-813c-c8cd0151e486}'] = true; // Open Profile Folder
    guid_list['{d2298e2c-535c-4ee3-b14e-8bc98a09e06d}'] = true; // sort extensions
    guid_list['{a1dba24b-f9f3-4b5f-9cdb-d6964322ca78}'] = true; // Ext2File
    guid_list['{f21f76b5-68e2-446d-96d5-c368d1af99e5}'] = true; // Ext2Abc
    guid_list['{00222227-0B44-4A6F-8F69-75A1479A20AA}'] = true; // Edit Config Files
    guid_list['{563e4790-7e70-11da-a72b-0800200c9a66}'] = true; // Clear Cache
    guid_list['{ec8030f7-c20a-464f-9b0e-13a3a9e97384}'] = true; // About:Config (ff) by Sonny Piers (pitux)
    guid_list['{1da2f540-ba45-4222-af1d-46422bbb6f5a}'] = true; // Simple Clear Button
    guid_list['{2018f39d-eceb-4657-97c0-5841cdba46ef}'] = true; // Simple EMButtons
    guid_list['aboutbtn@max.max']                       = true; // about button
    guid_list['{C49B68AC-0D21-40A7-9EE0-77D822273103}'] = true; // AboutPlug
    guid_list['{b4cdabd9-4790-41cd-a572-fc514bdbcb63}'] = true; // hideupdate    
    guid_list['{BB68DBF8-55E6-45A8-8F9F-D443EDDC12E8}'] = true; // Nightly Tester Tools Lite
    guid_list['{1a6907cb-d310-4d82-bded-c0dd31f8d9a2}'] = true; // Options Menu
    guid_list['{0144d588-cbef-e4ee-c964-59d725b9d524}'] = true; // Sanitize
    guid_list['{ced6cac8-3a7b-4550-b1fa-2ed0e3ca3707}'] = true; // about:kitchensink
    guid_list['{5B040A44-715B-11D9-B4F8-000A95DD92EA}'] = true; // config files editor
    guid_list['{2cf89d59-8610-4053-b207-85c6a128f65d}'] = true; // ChromEdit
    guid_list['{9932057A-82AA-4137-8199-C0F1656E26E2}'] = true; // An Options Toolbar
    guid_list['chromeditplus@webdesigns.ms11.net']      = true; // ChromEdit Plus
    guid_list['showextdir@exchangecode']                = true; // Show Extension Directory
    guid_list['profilefolder@webdesigns.ms11.net']      = true; // Profile Folder (JNewbry)
    guid_list['throbberbutton@aaron.pau']               = true; // Throbber Button
    guid_list['{06ebc538-7831-4f23-815d-5a5eda7db5c3}'] = true; // Simple Add-ons Button 
    guid_list['{F645A8C9-E969-42D9-B3F3-F325537222FD}'] = true; // QuickRestart 
    guid_list['{0dd39226-2650-404d-a43d-ffd906b35a9e}'] = true; // Clear Private Data... (Add-Ons)
    guid_list['{131AB333-2B69-4825-9791-757C048A9F8B}'] = true; // About Menu
    guid_list['addonssidebar@studio17.wordpress.com']   = true; // Add-ons Sidebar
    guid_list['extensionlistdumper@sogame.cat']         = true; // Extension List Dumper
    guid_list['Extended@spanglerco.com']                = true; // Extension Manager Extended
    //guid_list['{56ce9a60-b037-11d8-92e7-00d09e0179f2}'] = true; // Titlebar Tweaks
    //guid_list['titletweak@webdesigns.ms11.net']       = true; // Titlebar Tweaks - http://webdesigns.ms11.net/chromeditp.html

    switch (myBrandShortName) {
      case "Thunderbird":
        guid_list['{C81259E4-CFB8-43b2-8710-85144899A2F9}'] = true; // toggle preview pane
        guid_list['{75d29941-830a-7a83-0e09-181db5daba39}'] = true; // Disallow XPInstall
        guid_list['{287885B5-32A4-47bc-BD09-5A04E6D50B44}'] = true; // Get All Mail
        guid_list['GetAllMails@LN200704191215.net']         = true; // Get All Mails
        guid_list['{9F24D30B-97CA-4bb8-A7E2-C28340CB0101}'] = true; // EmButtons TB
        guid_list['{66d0afd6-d002-4d83-9943-486ffaf72a56}'] = true; // restart thunderbird
        guid_list['chromedit2@webdesigns.ms11.net']         = true; // ChromEdit 2

        var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());
        if (browserWindow.document.getElementById("cmd_aboutconfig")) {
          guid_list['{412395cf-187c-40a2-bc8c-3ca45ccdb3e8}'] = true; // about:config for TB 1.5 or newer
        }
        break;
      case "Calendar":
      case "Sunbird":
        guid_list['{e335bd25-8c75-4cd0-8989-9c702d9c316d}'] = true; // about:config sunbird
        break;
    }

    var nsIUpdateItem = Components.interfaces.nsIUpdateItem;
    var itemType = nsIUpdateItem.TYPE_EXTENSION;

    var liExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                  .getService(Components.interfaces.nsIExtensionManager);
              
    items = liExtensionManager.getItemList(itemType, { });

    for (var i in items) {
      if (typeof guid_list[items[i].id] != "undefined") {
        warning_list.push({_name:items[i].name, _guid:items[i].id, _version:items[i].version, 
                           toString:function() {return this._name.toLowerCase();}});
      }
    }

    if (warning_list.length == 0) {
      return;
    }
    
    try {
      warning_list.sort();
    } catch(ex) {
    }
    
    for (var w in warning_list) {
      outStr += " - " + warning_list[w]._name + " " + warning_list[w]._version + local_common.mCRLF;
    }

    var myPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
          .getService(Components.interfaces.nsIPromptService);
    
    var checkResult = {};

    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");

    var myDisableStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/disable_xpi_delay.properties");

    var retVal  = myPrompts.confirmCheck(window, myLocalStrings.GetStringFromName("appName"), 
      myLocalStrings.GetStringFromName("autoUninstallMsg1") + local_common.mCRLF + 
      myLocalStrings.GetStringFromName("autoUninstallMsg2") + local_common.mCRLF + 
      myLocalStrings.GetStringFromName("autoUninstallMsg3") + local_common.mCRLF + 
      local_common.mCRLF + outStr, 
      myDisableStrings.GetStringFromName("xpiMsgPrompt5"),
      checkResult);

    if (checkResult.value) {
      nsPreferences.setBoolPref("local_install.disableAutoUninstall", true);
    }
    
    if (retVal) {
      for (w in warning_list) {
        liExtensionManager.uninstallItem(warning_list[w]._guid);
      }

      var rds = liExtensionManager.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
      if (rds)
        rds.Flush();
  
      local_common.restartPrompt(true);
    }

  },
  
  init: function() {
    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");
    // myLocalStrings = document.getElementById("InstallButtonStrings");

    try {
      this.gBaseExtensionDir = local_common.getComplexPref(BASE_EXTENSION_DIR, local_common.myLocalFile)
    } catch(ex) {
    }

    try {
      this.gBaseThemeDir = local_common.getComplexPref(BASE_THEME_DIR, local_common.myLocalFile)
    } catch(ex) {
    }

    var fixSidebar = document.getElementById("extensionsEMbSidebar");
    if (fixSidebar) {
      fixSidebar.setAttribute("sidebarurl", "chrome://mozapps/content/extensions/extensions.xul");
    }

    fixSidebar = document.getElementById("themesEMbSidebar");
    if (fixSidebar) {
      fixSidebar.setAttribute("sidebarurl", "chrome://mozapps/content/extensions/extensions.xul");
    }

    return true;
  },

  init_emtm: function() {

    var myWindowState = Local_Install.myWindowState();
    var myTarget = nsPreferences.getIntPref("local_install.windowTarget");
    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    if (!top.document.getElementById('sidebar') && top.toString() != "[object Window]" &&
         myBrandShortName != "Thunderbird" &&  myTarget != 0) {

      if (browserWindow) {
        var mySideBar = browserWindow.document.getElementById('sidebar-box');
    
        if ((!mySideBar || mySideBar.getAttribute('sidebarcommand') != myWindowState + "EMbSidebar" && myTarget == 3) ||
           myTarget == 1 || myTarget == 2) {
          browserWindow.Local_Install.openManager(myWindowState, false);
        }
      }
    }
  
    Local_Install.saveDownloads();

    var emURL = "chrome://mozapps/content/extensions/extensions.xul"

    if (browserWindow && browserWindow.gBrowser && browserWindow.gBrowser.currentURI.spec != emURL && 
        myTarget != 0 && !top.document.getElementById('sidebar') && top.toString() != "[object Window]") {
      window.close();
    } 

    if (typeof installSkin == "function") {
      installSkin = function() { Local_Install.DoIt('theme') };
    }

    if (typeof installExtension == "function") {
      installExtension = function() { Local_Install.DoIt('extension') };
    }

    //var whichSlimMode = (myWindowState == "extensions") ? "Extension" : "Theme";
    //this.enableSlimMode(whichSlimMode);
    
    // Adds "Find Updates" to the title when updating
    var updateButton = document.getElementById('checkUpdatesAllButton');
    updateButton.addEventListener('DOMAttrModified', Local_Install.checkDisabled, true);

    // Adds View switching toggle for prefs
    var myViewGroupListener = document.getElementById('viewGroup');
    if (myViewGroupListener) {
      myViewGroupListener.addEventListener('DOMAttrModified', Local_Install.updateViewSwitch, true);
      window.addEventListener("unload", function() { 
        window.removeEventListener('DOMAttrModified', Local_Install.updateViewSwitch, true)}, 
        false);
    }
    this.emFixesThemeStartup(); // must run first to set visibility with SetEMVisibility as the creation & id are dynamic

    try {
      var thisCommandBar, thisResizer
      thisCommandBar = "commandBarBottom";
      thisResizer = "resizerBox";

      document.getElementById(thisCommandBar)
        .hidden = nsPreferences.getBoolPref("local_install.hideCommandBar");

      document.getElementById(thisResizer)  // hide grippie with commandbar
        .hidden = nsPreferences.getBoolPref("local_install.hideCommandBar");
    } catch(ex) {
    }

    var extensionBoxStyle = nsPreferences.copyUnicharPref("local_install.viewPadding")

    var viewBase = document.getElementById("extensionsView");

    if (((nsPreferences.getBoolPref("local_install.showPreviewVertically") || 
        nsPreferences.getBoolPref("local_install.showCommandBarOnTop")) && typeof aios_init == "undefined") && viewBase) {

      nsPreferences.setBoolPref("local_install.showPreviewVertically", true);

      viewBase.parentNode.orient = "vertical";
      viewBase.parentNode.setAttribute("style", "-moz-box-orient: vertical !important; " + extensionBoxStyle);

      if (nsPreferences.getBoolPref("local_install.showCommandBarOnTop")) {
        document.getElementById(thisCommandBar).hidden = false;
        nsPreferences.setBoolPref("local_install.hideCommandBar", false)

        var CommandBarContainer = viewBase.parentNode;
        CommandBarContainer.insertBefore(document.getElementById(thisCommandBar), viewBase);

        document.getElementById(thisCommandBar).setAttribute("style", extensionBoxStyle);
        document.getElementById(thisCommandBar).setAttribute("flex", "0");

        document.getElementById(thisResizer).hidden = true; // hide grippie with commandbar
      }

    }

    if (viewBase) {
      viewBase.setAttribute("style", extensionBoxStyle);
    } 
    
    var mySideBarTM = document.getElementById('themePreviewArea');
    if (mySideBarTM) {
      mySideBarTM.setAttribute("style", extensionBoxStyle);
    }

    var myextensionsBox = document.getElementById('extensionsBox');
    if (myextensionsBox) {
      myextensionsBox.setAttribute("style", extensionBoxStyle);
    }

    this.SetEMVisibility();

    /* Check for Auto-Uninstall Extensions */
    setTimeout(Local_Install.disableExtensions, 1000);

    /* Check for Extensions with Disabled Update Checks */
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch("extensions.");
    var prefCount = {value:0}; 
    var prefArray = nsIPrefBranchObj.getChildList("" , prefCount); 
    var item

    var thisPrefix = PREFIX_ITEM_URI;

    prefArray = local_common.filter(prefArray, function(c){return /(update\.enabled)/.test(c)});;

    for (var i = 0; i < prefArray.length; ++i) {
      item = document.getElementById(thisPrefix + prefArray[i].replace(/\.update\.enabled/g, ''))
      try {
        item.setAttribute("update.enabled", nsPreferences.getBoolPref("extensions." + prefArray[i]));
      } catch(ex) {
      }
    }
    
    // Run toggle after setting "update.enabled"
    var themeType = (myWindowState == "themes") ? "Themes" : "";

    themeType = (gView == "themes") ? "Themes" : "";

    var lastViewMode = nsPreferences.copyUnicharPref("local_install.lastViewMode" + themeType);

    if (lastViewMode != "all" && lastViewMode != "") {
      Local_Install.toggleFilter(lastViewMode, nsPreferences.copyUnicharPref("local_install.lastViewModeLabel" + themeType));
    }

  },

  checkDisabled: function(e) {
    
    myUpdaterTitle = "";

    if ((gView == "themes" || gView == "extensions") && 
       (e.attrName == "disabled" && e.newValue == "true")) {
      var updateButton = document.getElementById('checkUpdatesAllButton');
      myUpdaterTitle = "  ~" + updateButton.label + "~";
    }
    
  },

  updateViewSwitch: function(e) {
    if (e.attrName == "last-selected") {
      if (!/^urn\:/i.test(e.newValue)) {
        nsPreferences.setUnicharPref("local_install.addons_view_override", e.newValue)
      }
      setTimeout(Local_Install.toggleInstallButton, 100);  
    }
  },

  DoIt: function(aInstallType) {
    Local_Install.init();

    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");

    // 1) Prompt the user for the location of the theme to install. 
    var mFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(local_common.myFilePicker)
    var mDirectory = Components.classes["@mozilla.org/file/local;1"].createInstance(local_common.myLocalFile)

    try {
      var myBaseExtensionDir = local_common.getComplexPref(BASE_EXTENSION_DIR + "_local", local_common.myLocalFile)
    } catch(ex) {
    }

    try {
      var myBaseThemeDir = local_common.getComplexPref(BASE_THEME_DIR + "_local", local_common.myLocalFile)
    } catch(ex) {
    }

    if (aInstallType == "theme") {
      mFilePicker.init(window, myLocalStrings.GetStringFromName("windowTitle"), local_common.myFilePicker.modeOpenMultiple);

      if (myBaseThemeDir) {
        try {
          mDirectory.initWithPath(myBaseThemeDir.path);
          mFilePicker.displayDirectory = mDirectory;
        } catch(ex) {
        }
      } 

      mFilePicker.appendFilter(myLocalStrings.GetStringFromName("themesFilter"), "*.jar");

    } else {
      mFilePicker.init(window, myLocalStrings.GetStringFromName("windowTitleExt"), local_common.myFilePicker.modeOpenMultiple);

      if (myBaseExtensionDir) {
        try {
          mDirectory.initWithPath(myBaseExtensionDir.path);
          mFilePicker.displayDirectory = mDirectory;
        } catch(ex) {
        }
      } 
             
      mFilePicker.appendFilter(myLocalStrings.GetStringFromName("extensionsFilter"), "*.xpi");
    }
  
    mFilePicker.appendFilters(local_common.myFilePicker.filterAll);

    // 2) Show the file picker
    var retVal = mFilePicker.show()

    if (retVal == local_common.myFilePicker.returnOK) {
      //var prefs = nsPreferences.mPrefService;
      var mURL = "";
      var mIOService = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService)
      var mFileProtocolHandler = mIOService.getProtocolHandler("file")
                                   .QueryInterface(Components.interfaces.nsIFileProtocolHandler)
      
      // Hold current value of xpinstall pref
      var mXPInstallEnabled = nsPreferences.getBoolPref("xpinstall.enabled")
      
      // Force setting xpinstall.enabled to true, is reset afterwards
      nsPreferences.setBoolPref("xpinstall.enabled", true);

      var i = 1
      var xpi = new Array()
      var mEachFile
      var mFiles = mFilePicker.files

      try {
        while(mFiles.hasMoreElements()) {
          mEachFile = mFiles.getNext()
                      .QueryInterface(local_common.myLocalFile);

          mURL = mFileProtocolHandler.newFileURI(mEachFile)
                   .QueryInterface(Components.interfaces.nsIURL);

          xpi[i + ": " + unescape(mURL.fileName)] = { URL: mURL.spec,
                     IconURL: "chrome://local_install/content/icon.png",
                     toString: function () { return this.URL; }
                   };
          i++;
        }
      } catch(ex) {
      }
      
      if (aInstallType == "theme") {
        try {
          local_common.setComplexPref(BASE_THEME_DIR + "_local", local_common.myLocalFile, mEachFile.parent);
        } catch(ex) {
        }
      } else {
        try {
          local_common.setComplexPref(BASE_EXTENSION_DIR + "_local", local_common.myLocalFile, mEachFile.parent);
        } catch(ex) {
          local_common.debug(ex);
        }

      }
  
      InstallTrigger.install(xpi);

      // Set xpinstall.enabled back to original value
      nsPreferences.setBoolPref("xpinstall.enabled", mXPInstallEnabled);
    }

    return true;
  },
  
  embAddKeys: function() {
    
    var bToolsPref = nsPreferences.getBoolPref("local_install.ToolsExtension", false);
    var bThemesPref = nsPreferences.getBoolPref("local_install.ToolsThemes", false);
    var bOptionsPref = nsPreferences.getBoolPref("local_install.ToolsOptions", false);
    
    // Begin disabling key binding
    if (bToolsPref) {
      try {
        document.getElementById("key_installToolsExtensions").setAttribute("command", "");
      } catch(ex) {
      }
    }

    if (nsPreferences.getBoolPref("local_install.hideFileRestart")) {
      try {
        document.getElementById("key_restart").setAttribute("command", "");
      } catch(ex) {
      }
    }

    if (bThemesPref || myBrandShortName == "Thunderbird" || myBrandShortName == "Netscape" ) {
      try {
        document.getElementById("key_installToolsThemes").setAttribute("command", "");
      } catch(ex) {
      }
    }

    if (bOptionsPref) {
      try {
        document.getElementById("key_installToolsOptions").setAttribute("command", "");
      } catch(ex) {
      }
    }

    var allMenuItems = document.getElementsByTagName("menuitem");
    var hideMenuIcons = nsPreferences.getBoolPref("local_install.hideMenuIcons");

    var thisMenuCommand
    var thisMenuID
    for (var i = 0; i < allMenuItems.length; ++i) {
      thisMenuCommand = allMenuItems[i].getAttribute("command");
      thisMenuID = allMenuItems[i].getAttribute("id");

      // Extension Shortcut key already taken by Netscape 8.0/Nvu
      if (thisMenuCommand == "Tools:Extensions" || thisMenuID == "extensionsManager") {
        allMenuItems[i].setAttribute("local_install", "true");
        if (!bToolsPref && myBrandShortName != "Netscape") {
          allMenuItems[i].setAttribute("key", "key_installToolsExtensions");
        }
      }

      // Thunderbird has ctrl-shift-t as Get All
      if (thisMenuCommand == "Tools:Themes" || thisMenuID == "themesManager") {
        allMenuItems[i].setAttribute("local_install", "true");
        if (!bThemesPref && myBrandShortName != "Thunderbird" && myBrandShortName != "Netscape") {
          allMenuItems[i].setAttribute("key", "key_installToolsThemes");
        }
      }
     
      // Nvu/Mozilla Suite doesn't have an id and needs one to add menu icon
      if (myBrandShortName == "Mozilla") {
        if (allMenuItems[i].getAttribute("oncommand") == "toJavaScriptConsole();") {
          allMenuItems[i].setAttribute("id", "javascriptConsole");
          allMenuItems[i].setAttribute("local_install", "true");
        }
      }
    }

    if (!bOptionsPref) {
      var myOptionsMenu = document.getElementById("menu_preferences");
      if (myOptionsMenu) {
        myOptionsMenu.setAttribute("key","key_installToolsOptions");
        myOptionsMenu.setAttribute("local_install", "true");
      }
    }

    // Start remapping keys here
    try {
      document.getElementById("seqDown").setAttribute("modifiers","alt,shift");
      local_common.debug("Download Sort alt x key remapped to alt-shift x");
    } catch(ex) {
    }

    // Make JavaScript Console menu iconic
    try {
      document.getElementById("javascriptConsole").setAttribute("local_install", "true");
    } catch(ex) {
      // JS Console for Thunderbird as ID has capital S, damn
      try {
        document.getElementById("javaScriptConsole").setAttribute("local_install", "true");
      } catch(ex) {
      }
    }

    // Make Clear Privacy Button menu iconic
    try {
      document.getElementById("sanitizeItem").setAttribute("local_install", "true");
    } catch(ex) {
    }

    return true;
  },
  
  SetMenuVisibility: function() {

    try {
      if (nsPreferences.getBoolPref("local_install.hideRepairExtensions")) {
        document.getElementById("RepairExtensions").setAttribute("hidden", "true");
      } else {
        document.getElementById("RepairExtensions").setAttribute("hidden", "false");
      }
    } catch(ex) {
    }

    try {
      if (nsPreferences.getBoolPref("local_install.hideExtensionButtonMenu")) {
        document.getElementById("embuttonExtensions").setAttribute("type", "checkbox");
      } else {
        document.getElementById("embuttonExtensions").setAttribute("type", "menu-button");
      }
    } catch(ex) {
    }

    try {
      if (nsPreferences.getBoolPref("local_install.hideThemeButtonMenu")) {
        document.getElementById("embuttonThemes").setAttribute("type", "checkbox");
      } else {
        document.getElementById("embuttonThemes").setAttribute("type", "menu-button");
      }
    } catch(ex) {
    }

    try {
      if (nsPreferences.getBoolPref("local_install.myConfig.hideButtonMenu")) {
        document.getElementById("myconfig-button").setAttribute("type", "checkbox");
      } else {
        document.getElementById("myconfig-button").setAttribute("type", "menu-button");
      }
    } catch(ex) {
    }

    /* Hide extension & theme install menu options */
    try {
      document.getElementById("installExtensionMenu")
        .hidden = nsPreferences.getBoolPref("local_install.hideExtensionMenu"); 
      document.getElementById("installThemeMenu")
        .hidden = nsPreferences.getBoolPref("local_install.hideThemeMenu"); 
    } catch(ex) {
    }
    
    /* Hide menu seperator if extension & theme install menu options are hidden*/
    try {
      document.getElementById("menu_FileSepFx")
        .hidden = nsPreferences.getBoolPref("local_install.hideExtensionMenu") && nsPreferences.getBoolPref("local_install.hideThemeMenu"); 
      document.getElementById("menu_FileSepTb")
        .hidden = nsPreferences.getBoolPref("local_install.hideExtensionMenu") && nsPreferences.getBoolPref("local_install.hideThemeMenu"); 
    } catch(ex) {
    }

    Local_Install.hideRestartMenu();

    switch (myBrandShortName) {
      case "Mozilla":
        if (document.getElementById("new-exportConfig-menu")) {
          document.getElementById("new-exportConfig-menu")
            .hidden = true;
        }
        break;

      case "Thunderbird":
        break;

      default:  // should be Firefox, Deer Park, Navigator, etc.
    }

    Local_Install.setThrobberClick();

    try {
      document.getElementById("new-menu")
        .hidden = nsPreferences.getBoolPref("local_install.hideHelpAbout"); 
    } catch(ex) {
    }

    try {
      document.getElementById("aboutMenuSep")
        .hidden = nsPreferences.getBoolPref("local_install.hideHelpAbout"); 
    } catch(ex) {
    }

    try {
      document.getElementById("UMOExtensionContextPopup1")
        .hidden = nsPreferences.getBoolPref("local_install.hideHelpGetExtensions"); 
    } catch(ex) {
    }

    try {
      document.getElementById("UMOThemeContextPopup1")
        .hidden = nsPreferences.getBoolPref("local_install.hideHelpGetThemes"); 
    } catch(ex) {
    }

    try {
      document.getElementById("new-copyAgentBuildID-menu")
        .hidden = nsPreferences.getBoolPref("local_install.hideToolsBuildID"); 
    } catch(ex) {
    }

    // No My Config menu in Mozilla/Seamonkey
    if (myBrandShortName != "Mozilla") {
      try {
        document.getElementById("new-exportConfig-menu")
          .hidden = nsPreferences.getBoolPref("local_install.hideToolsMyConfig"); 
      } catch(ex) {
      }
    }

    try {
      document.getElementById("tools_edit_my_config")
        .hidden = nsPreferences.getBoolPref("local_install.hideToolsOpenProfile"); 
    } catch(ex) {
    }

    if (myBrandShortName == "Mozilla" || myBrandShortName == "Seamonkey") {
      nsPreferences.setBoolPref("local_install.hideToolsExtensionOptionsMenu", true)
      nsPreferences.setBoolPref("local_install.hideToolsThemeSwitcherMenu", true)
    }

    try {
      document.getElementById("tools_extension_options")
        .hidden = nsPreferences.getBoolPref("local_install.hideToolsExtensionOptionsMenu"); 
    } catch(ex) {
    }

    try {
      document.getElementById("tools_theme_switcher")
        .hidden = nsPreferences.getBoolPref("local_install.hideToolsThemeSwitcherMenu"); 
    } catch(ex) {
    }

    try {
      document.getElementById("installToolsOptionsMenu")
        .hidden = nsPreferences.getBoolPref("local_install.hideToolsOptionsMenu"); 
    } catch(ex) {
    }
  },

  SetEMVisibility: function() {
    if (myBrandShortName != "Mozilla") {

      var hideInstallButton = nsPreferences.getBoolPref("local_install.extensions.hideInstallButton")
      var myWindowState = Local_Install.myWindowState();

      this.enableSlimMode("Extension");
      this.enableSlimMode("Theme");

      if (!hideInstallButton) {
        /* Use default button for Thunderbird, Nvu, etc instead of my button */
        var defaultInstallButton = document.getElementById("installButton")
  
        if (defaultInstallButton) {
          var myInstallButton = document.getElementById("installNewThemeTemplate")
          myInstallButton.hidden = true;
  
          defaultInstallButton.setAttribute("command","");
          if (myWindowState == "themes") {
            defaultInstallButton.setAttribute("onclick","Local_Install.DoIt('theme');");
          } else {
            defaultInstallButton.setAttribute("onclick","Local_Install.DoIt('extension');");
          }
        } else if (myBrandShortName != "Thunderbird") {
  
          try {
            var buttonClone = document.getElementById("uninstallButton");
            if (document.getElementById("installNewTheme") != null) {
              document.removeElement("installNewTheme")
            }
  
            var buttonSeparator = document.getElementById("installButtonSeparator");
            var buttonInstallTemplate = document.getElementById("installNewThemeTemplate");
  
            var buttonNewSeparator = buttonSeparator.cloneNode(true);
            buttonNewSeparator.setAttribute("id", "installButtonSeparatorClone");
  
            var buttonNewInstall = buttonClone.cloneNode(true);
  
            buttonNewInstall.setAttribute("id", "installNewTheme");
            buttonNewInstall.setAttribute("disabled", "false");
            buttonNewInstall.removeAttribute("command");
            buttonNewInstall.setAttribute("label", buttonInstallTemplate.getAttribute("label"));
            buttonNewInstall.setAttribute("accesskey", buttonInstallTemplate.getAttribute("accesskey"));
            buttonNewInstall.setAttribute("tooltiptext", buttonInstallTemplate.getAttribute("tooltiptext"));
            buttonNewInstall.setAttribute("onclick", buttonInstallTemplate.getAttribute("onclick"));
  
            var container = buttonClone.parentNode;
            container.setAttribute("id", "commandButtonContainer");
            container.insertBefore(buttonNewSeparator, buttonClone);
            container.insertBefore(buttonNewInstall, buttonNewSeparator);
  
            buttonSeparator.setAttribute("hidden", "true");
            buttonInstallTemplate.setAttribute("hidden", "true");
          } catch(ex) {
          }
        }
      }

      // set properties for install button in addons window
      if (document.getElementById("installFileButton") && !hideInstallButton) {
        document.getElementById("installFileButton")
          .setAttribute("alwaysShow", nsPreferences.getBoolPref("local_install.showInstallButtonImage"));
      }

      Local_Install.toggleInstallButton();

      try {
        document.getElementById("installUpdatesAllButton")
          .setAttribute("alwaysShow", nsPreferences.getBoolPref("local_install.showEMButtonImages"));

        document.getElementById("restartAppButton")
          .setAttribute("alwaysShow", nsPreferences.getBoolPref("local_install.showEMButtonImages"));

        document.getElementById("checkUpdatesAllButton")
          .setAttribute("alwaysShow", nsPreferences.getBoolPref("local_install.showEMButtonImages"));

      } catch(ex) {
      }

      // hide Nightly Tester Tool button image
      try {
      document.getElementById("enableallButton")
        .setAttribute("alwaysShow", nsPreferences.getBoolPref("local_install.showEMButtonImages"));
      } catch(ex) {
      }

      if (document.getElementById("getMore")) {
        document.getElementById("getMore")
          .hidden = nsPreferences.getBoolPref("local_install.hideGetMoreLink");
        document.getElementById("getMore")
          .collapsed = nsPreferences.getBoolPref("local_install.hideGetMoreLink");
      }
      
      try {
        document.getElementById("manager-menubar")
          .hidden = nsPreferences.getBoolPref("local_install.hideManagerMenuBar"); 
      } catch(ex) {
      }
      
      try {
        document.getElementById("browseext-browse")
          .hidden = nsPreferences.getBoolPref("local_install.contextMenuHideBrowse"); 
      } catch(ex) {
      }

      try {
        document.getElementById("copyGUID")
          .hidden = nsPreferences.getBoolPref("local_install.contextMenuHideGUID"); 
      } catch(ex) {
      }

      try {
        if (nsPreferences.getBoolPref("local_install.contextMenuHideBrowse") 
            && nsPreferences.getBoolPref("local_install.contextMenuHideGUID")) {
          document.getElementById("browseext-sep")
            .hidden = true; 
        } else {
          document.getElementById("browseext-sep")
            .hidden = false; 
        }
      } catch(ex) {
      }

      try {
        document.getElementById("menuitem_moveTop")
          .hidden = nsPreferences.getBoolPref("local_install.contextMenuHideTop");
        document.getElementById("menuitem_moveUp")
          .hidden = nsPreferences.getBoolPref("local_install.contextMenuHideUp");
        document.getElementById("menuitem_moveDn")
          .hidden = nsPreferences.getBoolPref("local_install.contextMenuHideDown");
      } catch(ex) {
      }

      try {
        if (document.getElementById("menuitem_moveTop").hidden == true 
            && document.getElementById("menuitem_moveUp").hidden == true
            && document.getElementById("menuitem_moveDn").hidden == true) {
          document.getElementById("menuseparator_2")
            .hidden = true;
        } else {
          document.getElementById("menuseparator_2")
            .hidden = false;
        }
      } catch(ex) {
      }

      var themePreviewArea = document.getElementById("themePreviewArea")
      var extensionsView = document.getElementById("extensionsView")

      if (themePreviewArea) {
        themePreviewArea.persist = "width height";
      }

      if (typeof gView != "undefined") {
        if (gView == "themes") {
          themePreviewArea.hidden = nsPreferences.getBoolPref("local_install.hideThemePreview");
  
          document.getElementById("themeSplitter")
            .hidden = nsPreferences.getBoolPref("local_install.hideThemePreview");
        }
      }
      
      if (myWindowState == "themes") {
        themePreviewArea.hidden = nsPreferences.getBoolPref("local_install.hideThemePreview");

        try {
          document.getElementById("themeSplitter")
            .hidden = nsPreferences.getBoolPref("local_install.hideThemePreview");
          extensionsView.setAttribute("flex", "1");
          themePreviewArea.setAttribute("flex", "5");
          extensionsView.setAttribute("persist", "last-selected width height");
        } catch(ex) {
          try {
            extensionsView.setAttribute("flex", "1");
            extensionsView.setAttribute("width", document.getElementById("extensionsManager").width - 100);
            extensionsView.setAttribute("persist", "last-selected");
          } catch(ex) {
          }
        }
      }

    }

    Local_Install.hideRestartMenu();

    try {
      document.getElementById("myconfigAddons-button").hidden = !nsPreferences.getBoolPref("local_install.showAddonsMyConfigImage");
    } catch(ex) {
    }

    try {
      document.getElementById("addons-sort-button").hidden = !nsPreferences.getBoolPref("local_install.toggleAddonSortButton");
    } catch(ex) {
    }

    try {
      document.getElementById("addons-filter").hidden = !nsPreferences.getBoolPref("local_install.toggleAddonFilterField");
    } catch(ex) {
    }
    try {
      document.getElementById("embuttonExtensionsMenu").hidden = !nsPreferences.getBoolPref("local_install.showEMMenuButton");
    } catch(ex) {
    }
    try {
      document.getElementById("embuttonThemesMenu").hidden = !nsPreferences.getBoolPref("local_install.showTMMenuButton");
    } catch(ex) {
    }
    try {
      document.getElementById("infolister-buttonMenu").hidden = !nsPreferences.getBoolPref("local_install.showMyConfigMenuButton");
    } catch(ex) {
    }
    try {
      document.getElementById("restartfirefox-fileMenu2").hidden = !nsPreferences.getBoolPref("local_install.showRestartMenuButton");
    } catch(ex) {
    }

    // Hide/remove Button Labels
    if (nsPreferences.getBoolPref("local_install.hideButtonLabels")) {  
      var allButtons = document.getElementsByTagName("button");
      for (var b = 0; b < allButtons.length; b++) {
        try {
          allButtons[b].removeAttribute("label");
        } catch(ex) {
        }
      }
    }

    // Hide/remove menubar Labels
    if (nsPreferences.getBoolPref("local_install.hideAddonsbarLabels")) {  
      var allMenubars = document.getElementsByTagName("radio");
      for (var m = 0; m < allMenubars.length; m++) {
        try {
          allMenubars[m].removeAttribute("label");
        } catch(ex) {
        }
      }
    }

    // Right-Align Version Number in EM/TM Window
    local_common.insertCustomCSS("chrome://local_install/skin/emtm_right_align_version.css", nsPreferences.getBoolPref("local_install.rightAlignAddonVersion"));

  },

  enableSlimMode: function(thisType) {
    var thisToggle = nsPreferences.getBoolPref("local_install.slim" + thisType + "List");
    var thisCSS = "chrome://local_install/content/slim_list_new_school_" + thisType + ".css";
    local_common.insertCustomCSS(thisCSS, thisToggle);
  },
  
  openPreferences: function() {

    switch (myBrandShortName) {
      case "Mozilla":
        goPreferences('navigator', 'chrome://communicator/content/pref/pref-navigator.xul', 'navigator');
        break; 
      case "Thunderbird":
        openDialog("chrome://messenger/content/preferences/preferences.xul", "Preferences", 
          "chrome,titlebar,toolbar,centerscreen,resizable,dialog=no");
        break;
      case "Calendar":
      case "Sunbird":
        openPreferences();
        break;
      default:
        openDialog("chrome://browser/content/preferences/preferences.xul", "Preferences", 
          "chrome,titlebar,toolbar,centerscreen,resizable,dialog=no");
        break; 
    }
  },
  
  saveDownloads: function() {
    if (nsPreferences.getBoolPref("local_install.setAutoArchive")) {
      Local_Install.addInstallerObserver();

      // if (typeof window.arguments == "object") {
        // try {
          // var myParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
          // myDownloadManager.addDownloads(myParams);
        // } catch (ex) {
        // }
      // }
    }
  },
  
  archiveVault: function(thisFile, thisDir) {
    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");
    var myExtensionPath = null;

    if (!thisDir) {
      thisDir = /\.xpi$/i.test(thisFile) ? BASE_EXTENSION_DIR : BASE_THEME_DIR;
    }

    try {
      myExtensionPath = local_common.getComplexPref(thisDir);
    } catch(ex) {
    }
  
    while (!myExtensionPath) {
      var myPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
      
      var retVal  = myPrompts.confirm(window, myLocalStrings.GetStringFromName("appName"), 
            myLocalStrings.GetStringFromName("archivingPathMsg"));

      if (retVal) {
        nsPreferences.setIntPref('local_install.selected_settings_tab', 0);
        nsPreferences.setIntPref('local_install.selected_settings_sub_tab1', 1);
        
        this.openSettings(null, 'general_prefpane')
        myExtensionPath = local_common.getComplexPref(thisDir);
      } else {
        return;
      }
    }

    // Continue with archiving
    var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uri.spec = thisFile;

    var myDownloadURL = uri.spec;
    var url = uri.QueryInterface(Components.interfaces.nsIURL);

    if (myDownloadURL.length > 0 && uri.scheme != "file") {
      myExtensionPath.append(url.fileName);
      local_common.myListenerStartMsg = myLocalStrings.GetStringFromName("archiving") + " " + url.fileName;
      local_common.myListenerEndMsg = myLocalStrings.GetStringFromName("archivingFini");
      local_common.downloadFile(myDownloadURL, myExtensionPath.path);
    }

  },
    
  openManager: function(thisType, forceSidebar, forceTab) {
    // thisType == 'extensions'  or  thisType == 'themes'
    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    var addonsType = thisType;

    if (thisType == "installs") {
       addonsType = "installs";
       thisType = "extensions";        
    } 

    const EMTYPE = "Extension:Manager";
    const EM_ICON = "chrome://local_install/skin/" + thisType + "-small.png";

    var myLink = "chrome://mozapps/content/extensions/extensions.xul"

    nsPreferences.setUnicharPref("local_install.addons_view_override", addonsType)

    Local_Install.init();

    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");
    //myLocalStrings = document.getElementById("InstallButtonStrings");

    var openPref = nsPreferences.getIntPref("local_install.windowTarget");
    var myPref = (thisType == 'extensions') ? "local_install.ToolsExtension" : "local_install.ToolsThemes";
    var myWinName = (thisType == 'extensions') ? "myExtensions" : "myThemes";
    var panelTitle = (thisType == 'extensions') ? myLocalStrings.GetStringFromName("extensionLabel") : myLocalStrings.GetStringFromName("themeLabel");
    //var panelString = (thisType == 'extensions') ? "extensionsTitle" : "themesTitle";

    try {
      // Check each browser instance for our URL
      var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
               .getService(Components.interfaces.nsIWindowMediator);
    
      var winEnum = wm.getEnumerator(local_common.getWindowType());
      while (winEnum.hasMoreElements()) {
        var win = winEnum.getNext();
        var browser = win.getBrowser();
        if (browser.mTabs) {
          for (var i = 0; i < browser.mTabs.length; i++) {
            // aURL is a string
            if (myLink == browser.getBrowserForTab(browser.mTabs[i]).currentURI.spec) {
              try {
                win.focus(); // bring that window to the foreground
              } catch(ex) {
              }
              browser.selectedTab = browser.mTabs[i];
              return true;
            }
          }
        }
      }
    } catch(ex) {
    }

    var mySideBar = top.document.getElementById('sidebar-box');

    if (mySideBar) {
      var sidebarCommand = mySideBar.getAttribute('sidebarcommand');
    }

    if (forceTab != true) {
      if (openPref == 3 || forceSidebar || sidebarCommand == "extensionsEMbSidebar" || sidebarCommand == "themesEMbSidebar") {
//      if ((openPref == 3 && sidebarCommand != thisType + "EMbSidebar") || forceSidebar) {
        browserWindow.toggleSidebar(thisType + "EMbSidebar");
        return true;
      }
    }

    openPref = forceTab ? 1 : openPref

    var EMFEATURES = "chrome,menubar,extra-chrome,toolbar,dialog=no,resizable";

    switch (openPref) {
      case 1: // new tab
        var aboutBlank = null;

        try {
          aboutBlank = window._content.location.href == "about:blank";
        } catch(ex) {
        }

        if (aboutBlank){
          window._content.location.href = myLink;
        } else {
          browserWindow = local_common.mostRecentWindow(local_common.getWindowType()).getBrowser();

          var newTab = browserWindow.addTab(myLink, null);
          newTab.setAttribute("image", EM_ICON);
          browserWindow.selectedTab = newTab;
        }
        break;
  
      case 2: // current window
        window._content.location.href = myLink;
        break;

      default: //new window
        if (local_common.noWindowTypeToFocus(EMTYPE)) {
          // if (addonsType == "installs") {
            // window.openDialog(myLink, myWinName, EMFEATURES, installParams);
          // } else {
            window.openDialog(myLink, myWinName, EMFEATURES);
          // }
        }
    }

    return true;

  },
  
  openUMOsite: function(isExtensions) {

    var getMorePref = isExtensions ? "extensions.getMoreExtensionsURL" : "extensions.getMoreThemesURL";
    var mGetMoreURL = null;
 
    try {
      var formatter = Components.classes["@mozilla.org/toolkit/URLFormatterService;1"]
                                .getService(Components.interfaces.nsIURLFormatter);
      var mGetMoreURL = formatter.formatURLPref(getMorePref);
    } catch (ex) {
      mGetMoreURL = nsPreferences.getLocalizedUnicharPref(getMorePref);
      mGetMoreURL = mGetMoreURL.replace(/%APPID%/g, local_common.appID);
    }
    
    local_common.openURL(mGetMoreURL, true);
  },
  
  saveConfigurationInfo: function(aType, aTarget) {

    // replaced aClipboard & aDisplay to aTarget
    var today = new Date();

    var mySideBar = top.document.getElementById('sidebar-box');
    
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                 .createInstance(Components.interfaces.nsIFilePicker);

    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");

    local_common.populateSysVariables();

    var myProfileName = local_common.getSysVariable("Profile");

    var outFileName = myLocalStrings.GetStringFromName("filenamePrefix") + " - " + myBrandShortName;

    if (myProfileName){
      outFileName += " (" + myProfileName + ")"
    }

    outFileName += ".txt";

    var tagOpenLink = null;
    var tagEndLink = null;
    var tagCloseLink = null;
    var tagNewLine = local_common.mCRLF;

    var tagHeaderGenerated = ""
    var tagHeaderUserAgent = ""
    var tagHeaderBuildID = ""
    var tagHeaderExtension = ""
    var tagHeaderExtensionDisabled = ""
    var tagHeaderTheme = ""
    var tagHeaderPlugin = ""
    var tagHeaderEnd = ""
    var tagListDash = "- "
    var tagBoldBegin = "<b>"
    var tagBoldEnd = "</b>"
    var tagListBegin = tagNewLine
    var tagListEnd = ""

    var str = "";
    var tmpStr = "";

    switch (aType) {
      case "html":
        outFileName = myLocalStrings.GetStringFromName("filenamePrefix") + " - " + myBrandShortName;

        if (myProfileName){
          outFileName += " (" + myProfileName + ")"
        }
    
        outFileName += ".html";

        tagOpenLink = '<a href="';
        tagEndLink = '">';
        tagCloseLink = '</a>';
        tagNewLine = "<br>" + local_common.mCRLF;
        tagListBegin = "<ul>"
        tagListEnd = "</ul>"
        
        tagHeaderGenerated = "<span class='GeneratedHeader'>";
        tagHeaderUserAgent = "<span class='UserAgentHeader'>";
        tagHeaderBuildID   = "<span class='BuildIDHeader'>";
        tagHeaderExtension = "<span class='ExtensionHeader'>";
        tagHeaderExtensionDisabled = "<span class='ExtensionDisabledHeader'>";
        tagHeaderTheme = "<span class='ThemeHeader'>";
        tagHeaderPlugin = "<span class='PluginHeader'>";
        tagHeaderEnd = "</span>";
        tagListDash = "<li> "

        str = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">' + local_common.mCRLF;
        str += '<html><head><title>' + myLocalStrings.GetStringFromName("filenamePrefix");
        str += '- ' + myProfileName + '</title>' + local_common.mCRLF;
        str += '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">' + local_common.mCRLF;
        str += '<style type="text/css">' + local_common.mCRLF;

        var myStyle = nsPreferences.copyUnicharPref("local_install.myConfig.Style");
        
        if (myStyle == "") {
          myStyle = nsPreferences.copyUnicharPref("local_install.myConfig.Style.Default");
        }
    
        str += myStyle + local_common.mCRLF;
        str += '</style>' + local_common.mCRLF;
        str += '<base target="_blank">' + local_common.mCRLF;
        str += '</head>' + local_common.mCRLF;
        str += '<body>' + local_common.mCRLF;
        break;

      case "bbcode":
        outFileName = myLocalStrings.GetStringFromName("filenamePrefix") + " - " + myBrandShortName;

        if (myProfileName){
          outFileName += " (" + myProfileName + ")"
        }
    
        outFileName += " (BBCode).txt";

        tagOpenLink = '[url=';
        tagEndLink = ']';
        tagCloseLink = '[/url]';
        tagBoldBegin = "[b]"
        tagBoldEnd = "[/b]"

        tagHeaderGenerated = tagBoldBegin;
        tagHeaderUserAgent = tagBoldBegin;
        tagHeaderBuildID   = tagBoldBegin;
        tagHeaderExtension = tagBoldBegin;
        tagHeaderExtensionDisabled = tagBoldBegin;
        tagHeaderTheme = tagBoldBegin;
        tagHeaderPlugin = tagBoldBegin;
        tagHeaderEnd = tagBoldEnd;
        tagListDash = "- "

        break;
    }

    if (aTarget == "file") {
      fp.init(window, outFileName, fp.modeSave);
      fp.defaultString = outFileName;
      if (aType == "html") {
        fp.appendFilters(fp.filterHTML);
      } else {
        fp.appendFilters(fp.filterText);
      }
      fp.appendFilters(fp.filterAll);
  
      if (fp.show() == fp.returnCancel)
        return;
    }

    list=[];
    disabledlist=[];

    // ********************************************************
    // Generate Extensions List
    // ********************************************************
    if (nsPreferences.getBoolPref("local_install.myConfig.showDate")) {
      str += tagHeaderGenerated + myLocalStrings.GetStringFromName("txtGenerated") + tagHeaderEnd + " " + today + tagNewLine;
    }

    if (nsPreferences.getBoolPref("local_install.myConfig.showUserAgent")) {
      str += tagHeaderUserAgent + myLocalStrings.GetStringFromName("txtUserAgent") + tagHeaderEnd + " " + navigator.userAgent + tagNewLine;
    }

    if (nsPreferences.getBoolPref("local_install.myConfig.showBuildID")) {
      str += tagHeaderBuildID + myLocalStrings.GetStringFromName("txtBuildID") + tagHeaderEnd +  " " + local_common.buildID + tagNewLine;
    }

    str += tagNewLine;

    this.generateConfigData("Extension");
  
    if (nsPreferences.getBoolPref("local_install.myConfig.showExtensions")) {

      if (nsPreferences.getBoolPref("local_install.myConfig.SortList")) {
        try {
          list.sort();
        } catch(ex) {
        }
      }
  
      for(var i in list) { 
        switch (aType) {
          case "text":
            tmpStr += tagListDash + list[i]._name;
            if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionVersion") && list[i]._version.length > 0) {
              tmpStr += " " + list[i]._version;
            }
            if (nsPreferences.getBoolPref("local_install.myConfig.showGUID") && list[i]._guid.length > 0) {
              tmpStr += " - " + list[i]._guid;
            }

            if (nsPreferences.getBoolPref("local_install.myConfig.ShowTextLinks") && list[i]._homepage.length > 0) {
              tmpStr += ": " + list[i]._homepage;
            }

            if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionDescription") && list[i]._description.length > 0) {
              tmpStr += " - " + list[i]._description + local_common.mCRLF;
            } else {
              tmpStr += local_common.mCRLF;
            }
            break;
          case "html":
          case "bbcode":
            tmpStr += tagListDash + tagOpenLink + list[i]._homepage;
            
            if (aType == "html") {
              tmpStr += '" target="_blank';
            }

            tmpStr += tagEndLink;

            tmpStr += list[i]._name + tagCloseLink;

            if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionVersion") && list[i]._version.length > 0) {
              tmpStr += " " + list[i]._version;
            }

            if (nsPreferences.getBoolPref("local_install.myConfig.showGUID") && list[i]._guid.length > 0) {
              tmpStr += " - " + list[i]._guid;
            }
            if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionDescription") && list[i]._description.length > 0) {
              tmpStr += " - " + list[i]._description;
            }

            if (aType == "html") {
              tmpStr += "</li>";
            }

            tmpStr += local_common.mCRLF;
        }
      }
  
      str += tagHeaderExtension + myLocalStrings.GetStringFromName("txtEnabled") + tagHeaderEnd;
      str += " [" + list.length + "]" + tagListBegin + tmpStr + tagListEnd + tagNewLine;
    }

    if (nsPreferences.getBoolPref("local_install.myConfig.showDisabledExtensions")) {
      tmpStr="";

      if(disabledlist.length > 0) {
        if (nsPreferences.getBoolPref("local_install.myConfig.SortList")) {
          try {
            disabledlist.sort();
          } catch(ex) {
          }
        }
        for(i in disabledlist){
          switch (aType) {
            case "text":
              tmpStr += tagListDash + disabledlist[i]._name;
              if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionVersion") && disabledlist[i]._version.length > 0) {
                tmpStr += " " + disabledlist[i]._version;
              }
              if (nsPreferences.getBoolPref("local_install.myConfig.showGUID") && disabledlist[i]._guid.length > 0) {
                tmpStr += " - " + disabledlist[i]._guid;
              }
              if (nsPreferences.getBoolPref("local_install.myConfig.ShowTextLinks") && disabledlist[i]._homepage.length > 0) {
                tmpStr += ": " + disabledlist[i]._homepage;
              }
              if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionDescription") && disabledlist[i]._description.length > 0) {
                tmpStr += " - " + disabledlist[i]._description + tagNewLine;
              } else {
                tmpStr += tagNewLine;
              }
              break;
            case "html":
            case "bbcode":
              tmpStr += tagListDash + tagOpenLink + disabledlist[i]._homepage;

              if (aType == "html") {
                tmpStr += '" target="_blank';
              }

              tmpStr += tagEndLink;

              tmpStr += disabledlist[i]._name + tagCloseLink;

              if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionVersion") && disabledlist[i]._version.length > 0) {
                tmpStr += " " + disabledlist[i]._version;
              }

              if (nsPreferences.getBoolPref("local_install.myConfig.showGUID") && disabledlist[i]._guid.length > 0) {
                tmpStr += " - " + disabledlist[i]._guid;
              }

              if (nsPreferences.getBoolPref("local_install.myConfig.showExtensionDescription") && disabledlist[i]._description.length > 0) {
                tmpStr += " - " + disabledlist[i]._description;
              }

              if (aType == "html") {
                tmpStr += "</li>";
              }

              tmpStr += local_common.mCRLF;
          }
        } 
        str += tagHeaderExtensionDisabled + myLocalStrings.GetStringFromName("txtDisabled") + tagHeaderEnd;
        str += " [" + disabledlist.length + "]";
        str += tagListBegin + tmpStr + tagListEnd + tagNewLine + tagHeaderExtension + myLocalStrings.GetStringFromName("txtTotal");
        str += " " + (list.length + disabledlist.length) + tagHeaderEnd + tagNewLine + tagNewLine;
      } else {
        tmpStr = "";
      }
    }
    
    // ********************************************************
    // Generate Themes List
    // ********************************************************
    try {
    if (nsPreferences.getBoolPref("local_install.myConfig.showThemes")) {
      list=[];
  
      this.generateConfigData("Theme");
  
      // push default theme name manually, because some profiles report 2 default themes
      list.push({_name:defaultTheme,_guid:"{972ce4c6-7e08-4474-a285-3208198ce6fd}",_version:"", _description:"", _homepage:"http://www.mozilla.org/",
              _internalName:"classic/1.0", _optionsURL:"", _iconURL:"",
              toString:function(){return this._name.toLowerCase();}});

      if (nsPreferences.getBoolPref("local_install.myConfig.SortList") && list.length > 0) {
        try {
          list.sort();
        } catch(ex) {
        }
      }    

      tmpStr="";
  
      var selectedTheme = nsPreferences.copyUnicharPref("general.skins.selectedSkin")

      for(i in list) { 
        switch (aType) {
          case "text":
            tmpStr += tagListDash + list[i]._name;

            if (nsPreferences.getBoolPref("local_install.myConfig.showThemeVersion") && list[i]._version.length > 0) {
              tmpStr += " " + list[i]._version;
            }

            if (nsPreferences.getBoolPref("local_install.myConfig.showGUID") && list[i]._guid.length > 0) {
              tmpStr += " - " + list[i]._guid;
            }

            if (nsPreferences.getBoolPref("local_install.myConfig.ShowTextLinks")) {
              tmpStr += ": " + list[i]._homepage;
            }

            tmpStr += tagNewLine;
            if (nsPreferences.getBoolPref("local_install.myConfig.showThemeDescription") && list[i]._description.length > 0) {
              tmpStr += list[i]._description + tagNewLine;
            }
            break;
          case "html":
          case "bbcode":
            var tmpStr2 = tagOpenLink + list[i]._homepage;

            if (aType == "html") {
              tmpStr2 += '" target="_blank';
            }

            tmpStr2 += tagEndLink + list[i]._name;
            tmpStr2 += tagCloseLink;

            if (nsPreferences.getBoolPref("local_install.myConfig.showThemeVersion") && list[i]._version.length > 0) {
              tmpStr2 += " " + list[i]._version;
            }

            if (list[i]._internalName == selectedTheme) {
              tmpStr2 = tagBoldBegin + tmpStr2 + tagBoldEnd;
            }

            tmpStr += tagListDash + tmpStr2;

            if (nsPreferences.getBoolPref("local_install.myConfig.showGUID") && list[i]._guid.length > 0) {
              tmpStr += " - " + list[i]._guid;
            }

            if (nsPreferences.getBoolPref("local_install.myConfig.showThemeDescription") && list[i]._description.length > 0) {
              tmpStr += " - " + list[i]._description;
            }

            if (aType == "html") {
              tmpStr += "</li>";
            }

            tmpStr += local_common.mCRLF;
        }
      }
  
      str += tagHeaderTheme + myLocalStrings.GetStringFromName("txtInstalledThemes") + tagHeaderEnd;
      str += " [" + list.length + "]" + tagListBegin + tmpStr + tagListEnd + tagNewLine;
    
    } // end of themes if enabled
    } catch(ex) {
      local_common.debug(ex)
    }

    // ********************************************************
    // Generate Plugins List
    // ********************************************************
    if (nsPreferences.getBoolPref("local_install.myConfig.showPlugins")) {

      try { // try catch to avoid TB and others that don't have plugins
        navigator.plugins.refresh(false);
        var numPlugins = navigator.plugins.length;
    
        list=[];
        var pluginCount = 0;
        for (i = 0; i < numPlugins; i++) {
          var plugin = navigator.plugins[i];
      
          if (plugin) {
            list.push({_name:plugin.name,_description:plugin.description,_filename:plugin.filename,
                    toString:function(){return this._name.toLowerCase();}});
          }
        }

        // Can't use "local_install.myConfig.SortList" pref, plugins need to be sorted to collapse
        try {
          list.sort();
        } catch(ex) {
        }
    
        tmpStr = "";
        var tmpDupe = ""
        for (i in list) {
          if (tmpDupe == list[i]._name && !nsPreferences.getBoolPref("local_install.myConfig.ShowPluginFilename")) {
            continue;
          } else {
            pluginCount++
            tmpStr += tagListDash + list[i]._name;

            if (nsPreferences.getBoolPref("local_install.myConfig.ShowPluginFilename")) {
              tmpStr += ": " + list[i]._filename;
            } 

            tmpDupe = list[i]._name;
  
            if (nsPreferences.getBoolPref("local_install.myConfig.showPluginDescription") && list[i]._description.length > 0) {
              tmpStr += tagNewLine + " - " + list[i]._description;
            }

            if (aType == "html") {
              tmpStr += "</li>";
            }

            tmpStr += local_common.mCRLF;
          }
        }
    
        str += tagHeaderPlugin + myLocalStrings.GetStringFromName("txtPlugins") + tagHeaderEnd;
        str += " (" + pluginCount + ")" + tagListBegin + tmpStr + tagListEnd + tagNewLine;
      } catch(ex) {
      }
    } // end of plugins list if enabled

    if (aType == "html") {
      str += "</body></html>";
    }

    switch (aTarget) {
      case "display":
        this.displayInfo(aType, str);
        break;
      case "clipboard":
        local_common.copyToClipboard(str);
        break;
      default:
        str = local_common.convertUnicodeToUTF8(str);

        var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
                     .createInstance(Components.interfaces.nsIFileOutputStream);

        stream.init(fp.file, 0x20|0x02|0x08, 0666, 0);
        stream.write(str, str.length);
        stream.close();
    }

  },

  generateConfigData: function(aTarget) {

    function getRDFValue(thisElement, thisType) {
      try { 
        var thisArc = RDFService
                     .GetResource("http://www.mozilla.org/2004/em-rdf#" + thisType);
        var target = extensionDS.GetTarget(thisElement, thisArc, true);
        
        // Null Safety Check for null crasher on sorting names
        // Return blank string to avoid issue with name or description being blank
       
        if (target instanceof Components.interfaces.nsIRDFLiteral || 
            target instanceof Components.interfaces.nsIRDFInt)
           return (target.Value == null) ? "" : target.Value
      } catch(ex) {
      }
      
      return "";
    }

    var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                 .getService(Components.interfaces.nsIRDFService);
    var Container = Components.classes["@mozilla.org/rdf/container;1"]
                 .getService(Components.interfaces.nsIRDFContainer);
    var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
                 .getService(Components.interfaces.nsIExtensionManager).datasource;

    var whichRoot = "urn:mozilla:item:root";


    /* Pre-generate GUID list for name-id matchup later in loop */
    var guid_list = {};
  
    var myExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                                  .getService(Components.interfaces.nsIExtensionManager);
    var nsIUpdateItem = Components.interfaces.nsIUpdateItem;

    // get theme guids
    var itemType = nsIUpdateItem.TYPE_THEME;
    var items = [];

    try {
      items = myExtensionManager.getItemList(itemType, { });
    } catch(ex) {
      items = myExtensionManager.getItemList(null, itemType, { });
    }

    if (items) {
      for (var x in items) {
        guid_list[items[x].name] = items[x].id;
      }
    }

    // get extensions guids
    itemType = nsIUpdateItem.TYPE_EXTENSION;
    items = [];

    try {
      items = myExtensionManager.getItemList(itemType, { });
    } catch(ex) {
      items = myExtensionManager.getItemList(null, itemType, { });
    }

    if (items) {
      for (x in items) {
        guid_list[items[x].name] = items[x].id;
      }
    }
    /* End Pre-generating GUID list */

    var root = RDFService.GetResource(whichRoot);

    Container.Init(extensionDS, root);

    var elements = Container.GetElements();

    while(elements.hasMoreElements()) {
      var element = elements.getNext();
      element.QueryInterface(Components.interfaces.nsIRDFResource);
      
      var name = getRDFValue(element, "name");
      var guid = guid_list[name]; // hack to match by name
      var internalName = getRDFValue(element, "internalName");
      var creator = getRDFValue(element, "creator");
      var version = getRDFValue(element, "version");
      var thisType = getRDFValue(element, "type");
      
      var disabled = getRDFValue(element, "isDisabled");

      var homepageURL = getRDFValue(element, "homepageURL");
      var description = getRDFValue(element, "description");
      var optionsURL = getRDFValue(element, "optionsURL");
      var iconURL = getRDFValue(element, "iconURL");

      if (homepageURL.length == 0) {
        homepageURL = "http://www.google.com/search?q=" + escape(myBrandShortName + " " + name);
      }

      if (homepageURL.indexOf("www.") == 0) {
        homepageURL = "http://" + homepageURL; 
      }

      if(disabled && disabled == "true") {
        disabledlist.push({_name:name,_guid:guid,_version:version,_description:description,_homepage:homepageURL,
                           _internalName:internalName,_optionsURL:optionsURL,_iconURL:iconURL,
                           toString:function(){return this._name.toLowerCase();}});
      } else if(name.length > 0) {
        if (aTarget == "Extension" && thisType == 2) {
          list.push({_name:name,_guid:guid,_version:version,_description:description,_homepage:homepageURL,
                    _internalName:internalName,_optionsURL:optionsURL,_iconURL:iconURL,
                    toString:function(){return this._name.toLowerCase();}});
        } else if (aTarget == "Theme" && thisType == 4) {
          if (!/(classic\/1.0)/.test(internalName)) {
            list.push({_name:name,_guid:guid,_version:version,_description:description,_homepage:homepageURL,
                      _internalName:internalName,_optionsURL:optionsURL,_iconURL:iconURL,
                      toString:function(){return this._name.toLowerCase();}});
          } else {
            defaultTheme = name;
          }
        }
      }
    }

  },
  
  getTitle: function(thisTitle) {
    var myExtensionStrings = myLocalBundleService
          .createBundle("chrome://mozapps/locale/extensions/extensions.properties");
  
    var tmpTitle
    
    try {
      tmpTitle = myExtensionStrings.GetStringFromName(thisTitle);
    } catch (ex) {
      tmpTitle = thisTitle;
    }

    if (!nsPreferences.getBoolPref("local_install.showManagerTotals")) {
      return tmpTitle;
    }

    var view = document.getElementById("extensionsView");

    if (view) {
      var thisNodeName = "richlistitem"

      var exts = local_common.filter(view.childNodes, function(c){return c.nodeName==thisNodeName});
      
      var list_disabled = 0;

      for(var i = 0; i < exts.length; i++) {
        if(exts[i].getAttribute('isDisabled') == "true") {
          list_disabled++;
        }
      }
      
      switch (thisTitle) {
        case "themesTitle":
        case "extensionsTitle":
        case "Plugins":
        case "Installs":
        case "Updates":
        case "Add-ons":
          if (list_disabled == 0) {
            return tmpTitle + " [" + (exts.length) + "]";
          } else { 
            return tmpTitle + " [" + (exts.length - list_disabled) + "/" + list_disabled + "]";
          }
        default:
          return tmpTitle;
      }
    }

    return "";
  },
  
  setWindowTitle: function() {

    var myWindowState = Local_Install.myWindowState();
    if (typeof gView != "undefined") {
      myWindowState = (gView == "themes") ? "themes" : "extensions";
    }

    var thisTitle
    
    switch (gView) {
      case "extensions":
        thisTitle =  Local_Install.getTitle('extensionsTitle');
        break;
      case "themes":
        thisTitle = Local_Install.getTitle('themesTitle');
        break;
      case "plugins":
        thisTitle = Local_Install.getTitle('Plugins');
        break;
      case "updates":
        thisTitle = Local_Install.getTitle('Updates');
        break;
      case "installs":
        thisTitle = Local_Install.getTitle('Installs');
        break;
      case "locales":
        thisTitle = Local_Install.getTitle('Locales');
        break;
      default:
        thisTitle = Local_Install.getTitle('Add-ons');
        break;
    }

    var mySideBar = top.document.getElementById('sidebar-box');

    var themeType = (myWindowState == "themes") ? "Themes" : "";

    var lastViewMode = nsPreferences.copyUnicharPref("local_install.lastViewMode" + themeType);
    var viewTitleAppend = ""
    
    if (lastViewMode != "all" && lastViewMode != "") {
      viewTitleAppend = " (" + nsPreferences.copyUnicharPref("local_install.lastViewModeLabel" + themeType) + ")";
    }

    thisTitle += viewTitleAppend;

    if (mySideBar && myWindowState) {
      var sidebarTitle_obj = top.document.getElementById('sidebar-title');
      //var sidebarTitle_str = sidebarTitle_obj.getAttribute('value');
      sidebarTitle_obj.setAttribute("value", thisTitle + myUpdaterTitle);
    }
    
    //document.title = thisTitle + myUpdaterTitle;
    if (document.title != thisTitle + myUpdaterTitle) {
      document.title = thisTitle + myUpdaterTitle;
    }

    setTimeout(Local_Install.setWindowTitle, 200);
  },

  updateTitlebar: function() {
    try { document.getElementById("content").updateTitlebar(); } catch(ex) {}
  },
  
  initTitleListener: function() {
    try {
      document.getElementById("content").addEventListener("DOMTitleChanged", Local_Install.setTitleMode, false);
      try {
        gBrowser.mTabContainer.addEventListener("DOMNodeInserted", Local_Install.setTitleMode, true);
        gBrowser.mTabContainer.addEventListener("DOMNodeRemoved", function() { setTimeout(Local_Install.setTitleMode, 10) }, true);
      } catch(ex) {
      }
    } catch(ex) {
    }
  },

  setTitleMode: function() {
    try {
      var myModifier = "titlemodifier";
      var docElement = document.documentElement.getAttribute(myModifier);

      if (docElement) {
        if (nsPreferences.getBoolPref("local_install.showBuildinWindowTitle")) {
          local_common.populateSysVariables();
          var customModifier = local_common.generateText(nsPreferences.copyUnicharPref('local_install.titleTemplate')); 

          document.documentElement.setAttribute(myModifier, customModifier);
        } else {
          document.documentElement.setAttribute(myModifier, local_common.getOrigTitleModifier());
        }
  
        Local_Install.updateTitlebar();
      }

    } catch(ex) {
    }

    return true;
  },

  mySetTitleFromFolder: function(msgfolder, subject) {
    var wintype = document.documentElement.getAttribute('windowtype');
    var title; 

    // If we are showing the mail:3pane. Never include the subject of the selected
    // message in the title. ("Inbox for greenlantern@mozilla.org - Mozilla Thunderbird")
    // If we are a stand alone message window, we should show the Subject
    // and the product but not the account name: "Re: New window Title - Mozilla Thunderbird"

    if (wintype == "mail:messageWindow") {  
      title = subject ? subject : "";
    } else if (msgfolder) {
      title = msgfolder.prettyName;

      if (!msgfolder.isServer) {
        var server = msgfolder.server;
        var middle;
        var end;
        if (server.type == "nntp") {
          // <folder> on <hostname>
          middle = gMessengerBundle.getString("titleNewsPreHost");
          end = server.hostName;
        } else {
          var identity;
          try {
            var identities = accountManager.GetIdentitiesForServer(server);

            identity = identities.QueryElementAt(0, Components.interfaces.nsIMsgIdentity);
            // <folder> for <email>
            middle = gMessengerBundle.getString("titleMailPreHost");
            end = identity.email;
          } catch(ex) {}
          }
        if (middle) title += " " + middle;
        if (end) title += " " + end;
      }
    }

    if (nsPreferences.getBoolPref("local_install.showBuildinWindowTitle")) {
      local_common.populateSysVariables();
      var customModifier = local_common.generateText(nsPreferences.copyUnicharPref('local_install.titleTemplate')); 

      if (customModifier != null && customModifier != "") {
        title += " - " + customModifier;
      }
    } else {
      title += " - " + gBrandBundle.getString("brandShortName");
    }

    document.title = title;
  },

  setMultiWindowTitleMode: function() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var browserEnumerator = wm.getEnumerator(local_common.getWindowType());

    while (browserEnumerator.hasMoreElements()) { 
      var browser = browserEnumerator.getNext();
      browser.Local_Install.setTitleMode();
    }
  },

  register: function() {

    setTimeout(Local_Install.disableExtensions, 3000);

    setTimeout(Local_Install.setTitleMode, 100);

    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    this._observerService = Components.classes["@mozilla.org/observer-service;1"].
															getService(Components.interfaces.nsIObserverService);
    this._observerService.addObserver(this, "private-browsing", false);

		if (!prefBranch_LocalInstall) {
      prefBranch_LocalInstall = prefService.getBranch("local_install.");
      var pbi = local_common.getBranchPrefInterface(prefBranch_LocalInstall);
      pbi.addObserver("", this, false);
    }

    if (!prefBranch_themeChanged) {
      prefBranch_themeChanged = prefService.getBranch("extensions.lastSelectedSkin");
      var themeObs = local_common.getBranchPrefInterface(prefBranch_themeChanged);
      themeObs.addObserver("", themeObserver, false);
    }

    if (!prefBranch_throbber) {
      var myThrobberPref = null;
      switch (myBrandShortName) {
        case "Thunderbird":
          myThrobberPref = "messenger.throbber.url";
          break;
        case "Mozilla":
        case "SeaMonkey":
        case "Flock":
        default:
          myThrobberPref = "browser.throbber.url"
      }

      prefBranch_throbber = prefService.getBranch(myThrobberPref);
      var throbberObs = local_common.getBranchPrefInterface(prefBranch_throbber);
      throbberObs.addObserver("", throbberObserver, false);
    }

  },

  unregister: function() {
    this._observerService.removeObserver(this, "private-browsing");

		if (prefBranch_LocalInstall) {
			var pbi = local_common.getBranchPrefInterface(prefBranch_LocalInstall);
			pbi.removeObserver("", this);
		}

    if(prefBranch_themeChanged) {
			var themeObs = local_common.getBranchPrefInterface(prefBranch_themeChanged);
			themeObs.removeObserver("", themeObserver);
    }

    if(prefBranch_throbber) {
			var throbberObs = local_common.getBranchPrefInterface(prefBranch_throbber);
			throbberObs.removeObserver("", throbberObserver);
    }
  },

  observe: function(aSubject, aTopic, aData) {
    if (aTopic == "private-browsing") {
			Local_Install.setMultiWindowTitleMode();
    }

    if (aTopic != "nsPref:changed") return;

    //local_common.debug(aTopic + " " + aData);

    switch (aData) {
      case "hideThemePreview":
        // must run first to set visibility with SetEMVisibility as the creation & id are dynamic
        this.emFixesThemeStartup();
        break;
      case "myConfig.hideButtonMenu":
        // ignore regex below if changing myConfig toolbar button
        break;
      case "promptingToAutoUninstall":
      case "addons_view_override":
        return;
      default: 
        // don't make UI updates if updating lastViewMode or myConfig settings
        if (/^(lastViewMode)|^(myConfig\.)/.test(aData)) return;
    }

    if (document.documentElement.getAttribute("windowtype") == "Extension:Manager") {
      Local_Install.SetEMVisibility();
    } else {
      Local_Install.SetMenuVisibility();
      Local_Install.embAddKeys();
    }

    Local_Install.toggleMenuIcons();

    if (myBrandShortName != "Thunderbird") {
      Local_Install.setTitleMode();
    }
    return;
  },
  
  toggleExtensions: function(aSwitch) {
    var custDisableFunction = null;
    var custEnableFunction = null;
    
    var custAppEnable = null;
    
    var thisPrefix = null;
    var currentAction = null;
    var items = [];
    var item

    gExtensionsView.selectedItem = gExtensionsView.children[0];
    var selectedItem = gExtensionsView.selectedItem;
    var thisItemType
    
    if (typeof gItemType == "number") {
      thisItemType = gItemType;
    } else {
      thisItemType = (selectedItem.type == nsIUpdateItem.TYPE_THEME ? nsIUpdateItem.TYPE_THEME : nsIUpdateItem.TYPE_EXTENSION);
    }

    items = gExtensionManager.getItemList(thisItemType, { });
    thisPrefix = PREFIX_ITEM_URI;
    var myWindowState = Local_Install.myWindowState();

    for (var i in items) {
      item = document.getElementById(thisPrefix + items[i].id);

      if (aSwitch || item.getAttribute("opType") == "needs-enable") {
          if (/(\(default\))/.test(item.getAttribute("name")) || /(MR Tech Toolkit)/.test(item.getAttribute("name"))) {
            continue;
          }
          local_common.debug(items[i].id)

          if (aSwitch) {
            gExtensionManager.disableItem(items[i].id);
          } else {        
            gExtensionManager.enableItem(items[i].id);
          }
          item.setAttribute("opType", "needs-disable");
          
      } else if (!aSwitch || item.getAttribute("opType") == "needs-disable") {
          if (aSwitch) {
            gExtensionManager.disableItem(items[i].id);
          } else {        
            gExtensionManager.enableItem(items[i].id);
          }

          item.setAttribute("compatible", "true");
          item.setAttribute("opType", "needs-enable");
          //item.setAttribute("disabled", "false");
      }
    }
 
    flushDataSource();

    local_common.restartPrompt(true);
  },

  emFixesThemeStartup: function() {
    var myWindowState = Local_Install.myWindowState();

    //var addonsResizer = document.getElementById("resizerBox");
    if (!nsPreferences.getBoolPref("local_install.hideThemePreview") && myWindowState == "themes") {
      document.getElementById("themePreviewArea")
        .hidden = false;
      const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
      var themePreviewArea = document.getElementById("themePreviewArea");
      var container = themePreviewArea.parentNode;
      var themeSplitter = document.createElementNS(XUL_NS, "splitter");

      themeSplitter.setAttribute("id", "themeSplitter");
      container.setAttribute("id", "extensionsContainer");
      container.insertBefore(themeSplitter, themePreviewArea);
    }
  },

  pasteAgentBuildId: function(inText) {
    var ta = null;
    var val = null;

    try {
      ta = gContextMenu.target;
    } catch(ex) {
      ta = document.commandDispatcher.focusedElement;

      if (!ta) {
        return;
      }
    }

    val = inText;

    if (local_common.buildID != "null"){
      val += "Build ID: " + local_common.buildID;
    }

    var newpos = ta.selectionStart + val.length;

    ta.value = ta.value.substring(0, ta.selectionStart) + val
      + ta.value.substring(ta.selectionEnd,ta.value.length);

    ta.focus();
    ta.selectionStart=newpos;
    ta.selectionEnd=newpos;
  },

  popupload: function() {
    window.removeEventListener('load', Local_Install.popupload, true);

    var contextMenu = document.getElementById('contentAreaContextMenu');
    if (contextMenu) {
      contextMenu.addEventListener('popupshowing', Local_Install.popupshowing, true);
    }
    
    var extensionsCtxMenu = document.getElementById("extensionContextMenu");
    if (extensionsCtxMenu) {
      extensionsCtxMenu.addEventListener("popupshowing", Local_Install.emtmPopupShowing, false);
    }

    addonsCtxMenu = document.getElementById("addonContextMenu");
    if (addonsCtxMenu) {
      addonsCtxMenu.addEventListener("popupshowing", Local_Install.emtmPopupShowing, false);
    }

/*  Need more time to add Thunberbird past support
    contextMenu = document.getElementById('msgComposeContext');
    if (contextMenu) {
      contextMenu.addEventListener('popupshowing', Local_Install.popupshowing, true);
    }
*/
  },
    
  popupshowing: function() {
    try {
      gContextMenu.showItem("contextPasteAgentBuildId", gContextMenu.onTextInput && !nsPreferences.getBoolPref("local_install.hidePasteBuildID"));

      if (local_common.onLink()) {
        var myURI = local_common.linkURI();
        gContextMenu.showItem("contextArchiveXPI", /\.xpi$/i.test(myURI) && !nsPreferences.getBoolPref("local_install.hideArchiveXPI"));
        gContextMenu.showItem("contextArchiveJAR", /\.jar$/i.test(myURI) && !nsPreferences.getBoolPref("local_install.hideArchiveJAR"));
      } else {
        gContextMenu.showItem("contextArchiveXPI", false);
        gContextMenu.showItem("contextArchiveJAR", false);
      }
    } catch(ex) {
    }
  },

  emtmPopupShowing: function(event) {
    if (event.target == this) {

      var myMenuItemLabel = "";
      var myMenuItemCmd = "";

      var myLocalStrings = myLocalBundleService
            .createBundle("chrome://local_install/locale/local_install.properties");

      var item
  
      item = gExtensionsView.selectedItem;

      if (item && (gView == "extensions" || gView == "themes")) {
        var popup = document.getElementById("addonContextMenu");

        var baseMenuItem = document.createElement("menuitem");
        
        if (item.getAttribute("update.enabled") == "false" || item.getAttribute("updateable") == "false") {
            myMenuItemLabel = myLocalStrings.GetStringFromName("update.enabled.enable");
            myMenuItemCmd = "Local_Install.toggleUpdateCheck(true);";
        } else {
            myMenuItemLabel = myLocalStrings.GetStringFromName("update.enabled.disable");
            myMenuItemCmd = "Local_Install.toggleUpdateCheck(false);";
        }

        baseMenuItem = document.createElement("menuitem");
        baseMenuItem.setAttribute("id", "toggleUpdateCheck");
        baseMenuItem.setAttribute("label", myMenuItemLabel);
        baseMenuItem.setAttribute("oncommand", myMenuItemCmd);
        popup.appendChild(baseMenuItem);

        document.getElementById("browseext-browse").hidden = false;

      } else {
        document.getElementById("browseext-browse").hidden = true;
      }

    }

    return true;
  },

  toggleUpdateCheck: function(enable) {
    var selectedItem

    selectedItem = gExtensionsView.selectedItem;

    try {
      nsPreferences.setBoolPref("extensions." + getIDFromResourceURI(selectedItem.getAttribute("id")) +".update.enabled", enable)
    } catch(ex) {
      nsPreferences.setBoolPref("extensions." + stripPrefix(selectedItem.getAttribute("id"), selectedItem.type) +".update.enabled", enable)
    }

    selectedItem.setAttribute("update.enabled", enable)
    selectedItem.setAttribute("updateable", enable)

    var myWindowState = Local_Install.myWindowState();
    var themeType = (myWindowState == "themes") ? "Themes" : "";

    themeType = (gView == "themes") ? "Themes" : "";

    var lastViewMode = nsPreferences.copyUnicharPref("local_install.lastViewMode" + themeType);

    if (lastViewMode == "hidden") {
      Local_Install.toggleFilter(lastViewMode, nsPreferences.copyUnicharPref("local_install.lastViewModeLabel" + themeType));
    }
    
  },

  closeSidebar: function() {
    var mySideBar = top.document.getElementById('sidebar-box');

    if (mySideBar) {
      top.window.toggleSidebar(mySideBar.getAttribute('sidebarcommand'));
    } else {
      top.window.close();
    }
  },

  displayInfo: function(aType, aData) {
    var doc = document.getElementById("infoFrame").contentDocument;
    var body = doc.getElementsByTagName("body")[0];

    if (aType == "html") {
      body.innerHTML = aData;
    } else {
      body.innerHTML = "<pre>" + aData + "</pre>";
    }

  },

  onFrameClick: function(e) {
    //var mySideBar = top.document.getElementById('sidebar-box');

    //if(e.target.localName.toLowerCase() == "a" && (!mySideBar || local_common.getWindowType() == "emusic:window")) {
    if(e.target.localName.toLowerCase() == "a") {
      e.preventDefault();
      //e.preventBubble();
      e.stopPropagation();
      
      var myURL = e.target.href;

      if (myURL && e.button == 0) {
        local_common.openURL(myURL, true, true);
      } else {
        local_common.openURL(myURL, true, false);
      }
    }
  },
  
  addInstallerObserver: function() {
    myDownloadManager = new myXPInstallDownloadManager();
    //var myOS = Components.classes["@mozilla.org/observer-service;1"]
    //                   .getService(Components.interfaces.nsIObserverService);
    //myOS.addObserver(myDownloadManager, "xpinstall-download-started", false);

    // observer may get removed by sidebar/tab redirect (i think still working on this)
    // setTimeout should help with this
    setTimeout(function() {
      try {
        myObserverIndex = gExtensionManager.addUpdateListener(myDownloadManager); myObserverStack.push(myObserverIndex);
      } catch (ex) {
        myObserverIndex = gExtensionManager.addInstallListener(myDownloadManager); myObserverStack.push(myObserverIndex);
        local_common.debug(ex)
      }
    }, 0);

  },

  removeInstallerObserver: function() {
    try {
      //local_common.debug(myObserverStack.length)
      var thisObserverIndex = myObserverStack.pop();
      gExtensionManager.removeUpdateListenerAt(thisObserverIndex);
      //local_common.debug(myObserverStack.length)
    } catch(ex) {
    }

    if (myDownloadManager) {
      var myOs = Components.classes["@mozilla.org/observer-service;1"]
                         .getService(Components.interfaces.nsIObserverService);
      myOs.removeObserver(myDownloadManager, "xpinstall-download-started");

      myDownloadManager = null;
    }
  },
  
  openMyConfig: function(forceTab, forceSidebar) {

    var openPref = nsPreferences.getIntPref("local_install.windowTargetMyConfig");
    var myLink = "chrome://local_install/content/infolister.xul"

    openPref = forceTab ? 1 : openPref
    openPref = forceSidebar ? 3 : openPref

    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    switch (openPref) {
      case 1: // New Tab
        var aboutBlank = null;
        try {
          aboutBlank = window._content.location.href == "about:blank"
        } catch(ex) {
        }

        if (aboutBlank){
          window._content.location.href = myLink;
        }  else {
          try {
            var thisWindow = browserWindow.getBrowser();
            var newTab = thisWindow.addTab(myLink, null, null);
            thisWindow.selectedTab = newTab;
          } catch(ex) {
          }
        }
        break;
  
      case 2: // new window
        if (local_common.noWindowTypeToFocus("myconfig:window")) {
          openDialog(myLink, 'aboutMyConfig', 'chrome,dialog=no,centerscreen');
        }
        break;

      case 3: // sidebar
        browserWindow.toggleSidebar("myConfigSidebar");
        break;   

      default: // current window or page
        try {
          window._content.location.href = myLink;
        } catch(ex) {
        }
    }

  },

  openChromeEditor: function(forceTab) {

    var openPref = nsPreferences.getIntPref("local_install.windowTargetChromeEditor");
    var myLink = "chrome://local_install/content/chromedit.xul"

    openPref = forceTab ? 1 : openPref

    switch (openPref) {
      case 1: // New Tab
        var aboutBlank = null;
        try {
          aboutBlank = window._content.location.href == "about:blank"
        } catch(ex) {
        }

        if (aboutBlank){
          window._content.location.href = myLink;
        }  else {
          try {
            var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());
            var thisWindow = browserWindow.getBrowser();
            var newTab = thisWindow.addTab(myLink, null, null);
            thisWindow.selectedTab = newTab;
          } catch(ex) {
          }
        }
        break;
  
      case 2: // new window
        if (local_common.noWindowTypeToFocus("global:ChromEditWindow")) {
          openDialog(myLink, 'aboutMyConfig', 'chrome,dialog=no,centerscreen');
        }
        break;

      default: // current window or page
        try {
          window._content.location.href = myLink;
        } catch(ex) {
        }
    }

  },

  openSettings: function (myOptions, myPane) {
    myOptions = myOptions == null ? 'chrome,titlebar,toolbar,resizable,centerscreen' : myOptions;

    if (local_common.noWindowTypeToFocus("local_install:settings")) {
      openDialog('chrome://local_install/content/settings/settings.xul', 'local_install', myOptions, myPane);
    }
  },
  
  openThrobber: function (inNewTab) {
    if (local_common.thunderClick(local_common.getThrobberURL(), inNewTab))  {
      return;
    }
    local_common.openURL(local_common.getThrobberURL(), inNewTab);
  },
  
  makeAllCompatible: function() {
    var retVal;
    var appinfo = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo);
    var version = appinfo.version;
    
    gExtensionsView.selectedItem = gExtensionsView.children[0];
    var selectedItem = gExtensionsView.selectedItem;
    var thisItemType

    if (typeof gItemType == "number") {
      thisItemType = gItemType;
    } else {
      thisItemType = (selectedItem.type == nsIUpdateItem.TYPE_THEME ? nsIUpdateItem.TYPE_THEME : nsIUpdateItem.TYPE_EXTENSION);
    }
    
    var items = gExtensionManager.getItemList(thisItemType, { });

    for (var i in items) { 
      if (myExtensionAppEnabler.isCompatible(items[i].id) == false) {
        retVal = myExtensionAppEnabler.makeCompatible(PREFIX_ITEM_URI + items[i].id, appinfo.ID, version);
      }
    }
  
  },
  
  checkForUpdates: function() {
    checkUpdatesAll()
  },
  
  createDropDownMenu: function(myPopup, thisType) {
    var aMenuItem = "";
    var thisAction = "";
    var genericIcon = "";
    list = [];
    disabledlist = [];

    while(myPopup.hasChildNodes()) {
      myPopup.removeChild(myPopup.firstChild);
    }
    
    this.generateConfigData(thisType);

    if (thisType == 'Theme') {
      genericIcon = "chrome://local_install/skin/themes-small.png";

      /* Get current theme */
      var selectedTheme = nsPreferences.copyUnicharPref("general.skins.selectedSkin")
      list.push({_name:defaultTheme,_guid:"{972ce4c6-7e08-4474-a285-3208198ce6fd}",_version:"",_description:"",_homepage:"http://www.mozilla.org/",
              _internalName:"classic/1.0",_optionsURL:"",_iconURL:"",
              toString:function(){return this._name.toLowerCase();}});
      var extDir = "";
      
      /* Pre-generate Theme list for icon name-id matchup later in loop */
      var theme_list = {};
    
      var myExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                                    .getService(Components.interfaces.nsIExtensionManager);
      var nsIUpdateItem = Components.interfaces.nsIUpdateItem;
      var itemType = nsIUpdateItem.TYPE_THEME;

      var items = [];

      try {
        items = myExtensionManager.getItemList(itemType, { });
      } catch(ex) {
        items = myExtensionManager.getItemList(null, itemType, { });
      }

      if (items) {
        for (var x in items) {
          theme_list[items[x].name] = items[x].id;
        }
      }
    } else {
      genericIcon = "chrome://local_install/skin/extensions-small.png";
    }

    list.sort();
    
    var themeIconFile;
  
    for(var i in list) {
      if (list[i]._optionsURL || thisType == "Theme") {
        //try {
          aMenuItem = document.createElement("menuitem");
          aMenuItem.setAttribute("label", list[i]._name + " " + list[i]._version);
          aMenuItem.setAttribute("tooltiptext",  list[i]._description);
          aMenuItem.setAttribute("class", "menuitem-iconic menuitem-fix");

          if (thisType == "Extension") {
            if (list[i]._optionsURL.indexOf("chrome") == 0) {
              thisAction = "openDialog('" + list[i]._optionsURL + "', '" + list[i]._name + 
                           "','chrome,toolbar,centerscreen,resizable,dialog=yes')";
            } else {
              thisAction = list[i]._optionsURL.replace(/\opener\./g, '');
              thisAction = thisAction.replace(/\window\.close\(\)\;/g, '')
            }
          } else {
            if (list[i]._internalName == selectedTheme) {
              aMenuItem.setAttribute("style", "font-weight : bold;");
            }

            thisAction = "Local_Install.switchTheme('" + list[i]._internalName + "')";
          }

          aMenuItem.setAttribute("oncommand", thisAction + "; event.stopPropagation();");

          if (list[i]._iconURL) {
            aMenuItem.setAttribute("image", list[i]._iconURL);
          } else {
            if (thisType == "Extension") {
              aMenuItem.setAttribute("image", genericIcon);
            } else {
              themeIconFile = local_common.getSpecialFolder('ProfD');
              themeIconFile.append("extensions");
              themeIconFile.append(theme_list[list[i]._name]);
              themeIconFile.append("icon.png");

              if (themeIconFile.exists()) {
                aMenuItem.setAttribute("image", local_common.getURLSpecFromFile(themeIconFile));
              } else {
                aMenuItem.setAttribute("image", genericIcon);
              }
            }
          }
        /*} catch(ex) {
        }*/

        myPopup.appendChild(aMenuItem);
      }
    }
  },
  
  switchTheme: function(newTheme) {
  
    var retVal = "";
    var PREF_EXTENSIONS_DSS_ENABLED           = "extensions.dss.enabled";
    var PREF_EXTENSIONS_DSS_SWITCHPENDING     = "extensions.dss.switchPending";
    var PREF_EM_LAST_SELECTED_SKIN            = "extensions.lastSelectedSkin";
    var PREF_GENERAL_SKINS_SELECTEDSKIN       = "general.skins.selectedSkin";

    if (nsPreferences.getBoolPref(PREF_EXTENSIONS_DSS_ENABLED)) {
      nsPreferences.setUnicharPref(PREF_GENERAL_SKINS_SELECTEDSKIN, newTheme);
    } else {
      nsPreferences.setBoolPref(PREF_EXTENSIONS_DSS_SWITCHPENDING, true);
    }

    nsPreferences.setUnicharPref(PREF_EM_LAST_SELECTED_SKIN, newTheme);
    
  },
  
  hideRestartMenu: function() {

    try {
      var restartMenu = document.getElementById("restartfirefox-fileMenu");
      var restartMenu2 = document.getElementById("restartfirefox-fileMenu2");
      var restartSpacer = document.getElementById("restart-spacer");
      var restartLabel = document.getElementById("restart");
  
      if (nsPreferences.getBoolPref("local_install.hideFileRestart")) {
        restartMenu.hidden = true;
        if (restartMenu2) {
          restartMenu2.hidden = true;
          if (restartSpacer) {
            restartSpacer.hidden = true;
          }
        }
      } else if (restartLabel) {
        restartMenu.hidden = false;
        restartMenu.setAttribute("label", restartLabel.getAttribute("label") + " " + myBrandShortName);

        if (restartMenu2) {
          restartMenu2.hidden = false;
          restartMenu2.setAttribute("tooltiptext", restartLabel.getAttribute("label") + " " + myBrandShortName);
          if (restartSpacer) {
            restartSpacer.hidden = false;
          }
        }
      }
    } catch(ex) {
    }
  },

  clearCache: function() {
    var cacheClass = Components.classes["@mozilla.org/network/cache-service;1"];
    var cacheService = cacheClass.getService(Components.interfaces.nsICacheService);

    try {
      cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
      cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
    } catch(ex) {
    }
  },

  showCustomUpdateThrobber: function() {
   local_common.insertCustomCSS("chrome://local_install/content/emtm_throbber.css", true);
  },
  
  myExtensionUpdateNow: function (aEvent) {
    if (nsPreferences.getBoolPref("local_install.setAutoArchive")) {
      var gExtensionDB = gExtensionsView.database;
  
      var rdfs = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                           .getService(Components.interfaces.nsIRDFService);
    
      var extension = rdfs.GetResource(aEvent.target.id);                       
  
      var availableUpdateURL = rdfs.GetResource("http://www.mozilla.org/2004/em-rdf#availableUpdateURL");
      var myUpdateUrl = gExtensionDB.GetTarget(extension, availableUpdateURL, true);
      myUpdateUrl = myUpdateUrl.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  
      var thisDir = /\.xpi$/i.test(myUpdateUrl) ? BASE_EXTENSION_DIR : BASE_THEME_DIR;
  
      Local_Install.archiveVault(myUpdateUrl, thisDir)
    }

    oldExtensionUpdateNow(aEvent);
  },
  
  toggleFilter: function(myToggle, myLabel) {

    var myWindowState = Local_Install.myWindowState();
    var themeType = (myWindowState == "themes") ? "Themes" : "";

    themeType = (gView == "themes") ? "Themes" : "";

    nsPreferences.setUnicharPref("local_install.lastViewMode" + themeType, myToggle)
    nsPreferences.setUnicharPref("local_install.lastViewModeLabel" + themeType, myLabel)

    for (var i = 0; i < gExtensionsView.childNodes.length; ++i) {
      gExtensionsView.childNodes[i].removeAttribute("hidden");
    }

    var thisAttrib = ""
    var thisValue = ""
    
    switch (myToggle) {
      case "enabled":
        thisAttrib = "isDisabled"
        thisValue = "false"
        break;
      case "disabled":
        thisAttrib = "isDisabled"
        thisValue = "true"
        break;
      case "hidden":
        thisAttrib = "update.enabled"
        thisValue = "false"
        break;
      default:
        return false;
    }

    for (i = 0; i < gExtensionsView.childNodes.length; ++i) {
        var item = gExtensionsView.childNodes[i];

        if (item.getAttribute(thisAttrib) != thisValue) {
            item.setAttribute("hidden", "true");
        }
    }

    return true;
  },
  
  myUN_InstallUpdates: function() {
    if (nsPreferences.getBoolPref("local_install.setAutoArchive")) {
      var itemList = new Array();
      var thisDir
      var currItem
      var currURL

      var numUpdates = UN_gOverlay._updates.getNumItems();

      for (var i = 0; i < numUpdates; i++) {
        currItem = this._updates.getItemByIndex(i);
        currURL = UN_getAddon(currItem.id).xpiURL
        
        thisDir = /\.xpi$/i.test(currURL) ? BASE_EXTENSION_DIR : BASE_THEME_DIR;
    
        Local_Install.archiveVault(currURL, thisDir)
      }
    }

    UN_gOverlay._updates.installUpdates();;
  },
  
  showAttachmentBox: function() {
    var attachmentBox = document.getElementById("attachments-box");
    if (attachmentBox && nsPreferences.getBoolPref("local_install.showAttachmentBox")) {
      try {
        attachmentBox.hidden = false;
        document.getElementById("attachmentbucket-sizer").hidden = false;

        attachmentBox.collapsed = false;
        document.getElementById("attachmentbucket-sizer").collapsed = false;
      } catch(ex) {
      }
    }
  },

  checkForMiddleClick: function(node, event) {
    // Used as an onclick handler for UI elements with link-like behavior.
    // e.g. onclick="checkForMiddleClick(this, event);"
    
    if (event.button == 1) {
      event.stopPropagation();
      /* Execute the node's oncommand.
       * Using eval() because of bug 246720.  Would like to use node.oncommand(event).
       * Since we're using eval():
       * |event| is correct because the name of this function's formal parameter matches
       * the automatic name of the formal parameter for oncommand, |event|.
       *
       * |this| is incorrect.  To make it correct, we would have to use Function.call.
       */
//      eval(node.getAttribute("oncommand"));
      switch (node.getAttribute("id")) {
        case "embuttonExtensions":
          switch (myBrandShortName) {
            case "Thunderbird":
            case "Calendar":
            case "Sunbird":
              Local_Install.openManager('extensions');
              return true;
            default:
              Local_Install.openManager('extensions', false, true);
              return true;
          }
          return true;
        case "embuttonThemes":
          switch (myBrandShortName) {
            case "Thunderbird":
            case "Calendar":
            case "Sunbird":
              Local_Install.openManager('themes');
              return true;
            default:
              Local_Install.openManager('themes', false, true);
              return true;
          }
          return true;
        case "infolister-buttonMenu":
        case "myconfig-button":
          switch (myBrandShortName) {
            case "Thunderbird":
            case "Calendar":
            case "Sunbird":
              Local_Install.openMyConfig(false);
              return true;
            default:
              Local_Install.openMyConfig(true);
              return true;
          }
          break;
        case "aboutConfig-button":
          local_common.openSeasame('about:config', 'forceTab');
          return true;
        case "aboutPlugins-button":
          local_common.openSeasame('about:plugins', 'forceTab');
          return true;
        case "editconfigfiles-toolbar-button":
          switch (myBrandShortName) {
            case "Thunderbird":
            case "Calendar":
            case "Sunbird":
              Local_Install.openChromeEditor(false);
              return true;
            default:
              Local_Install.openChromeEditor(true);
              return true;
          }
          break;
        case "navigator-throbber":
          Local_Install.openThrobber(true, event);
          break;
      }
  
      // If the middle-click was on part of a menu, close the menu.
      // (Menus close automatically with left-click but not with middle-click.)
      //closeMenus(event.target);
      } else if (node.getAttribute("id") == "navigator-throbber" && event.button == 0) {
        Local_Install.openThrobber(false, event);
      }
    return true;
  },
  
  repairExtensions: function() {

    var myPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
          .getService(Components.interfaces.nsIPromptService);
    
    var myLocalStrings = myLocalBundleService
          .createBundle("chrome://local_install/locale/local_install.properties");

    var retVal  = myPrompts.confirm(window, myLocalStrings.GetStringFromName("appName"), 
          myLocalStrings.GetStringFromName("repairPrompt") + "\n\n" +
          myLocalStrings.GetStringFromName("repairPromptNote"));

    if (!retVal) {
      return;
    }

    var extDir = local_common.getSpecialFolder('ProfD');

    extDir.append("extensions");
    extDir.append("staged-xpis");
    
    try {
      Local_Install.removeDirRecursive(extDir);
    } catch(ex) {
    }

		var fileLocal = Components.classes["@mozilla.org/file/local;1"]
                      .getService(Components.interfaces.nsILocalFile);

    extDir = local_common.getSpecialFolderPath('ProfD')

    try {
  		fileLocal.initWithPath(extDir);
      fileLocal.append("extensions.rdf");
      fileLocal.permissions = 0644;
      fileLocal.remove(false);
    } catch(ex) {
    }

    try {
  		fileLocal.initWithPath(extDir);
      fileLocal.append("extensions.ini");
      fileLocal.permissions = 0644;
      fileLocal.remove(false);
    } catch(ex) {
    }

    try {
  		fileLocal.initWithPath(extDir);
      fileLocal.append("extensions.cache");
      fileLocal.permissions = 0644;
      fileLocal.remove(false);
    } catch(ex) {
    }

    local_common.restartPrompt(true);
  },
  
  removeDirRecursive: function(dir) {
    var PERMS_FILE      = 0644;
    var PERMS_DIRECTORY = 0755;

    try {
      dir.remove(true);
      return;
    }
    catch(ex) {
    }
  
    var dirEntries = dir.directoryEntries;
    while (dirEntries.hasMoreElements()) {
      var entry = dirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
  
      if (entry.isDirectory()) {
        Local_Install.removeDirRecursive(entry);
      }
      else {
        entry.permissions = PERMS_FILE;
        entry.remove(false);
      }
    }
    dir.permissions = PERMS_DIRECTORY;
    dir.remove(true);
  },
  
  myWindowState: function() {
    // myWindowState is either "extensions" or "themes"
    var thisType = window.location.search.substr("?type=".length, window.location.search.length)
    return (!thisType ? "extensions" : thisType);
  },
  
  toggleMenuIcons: function() {
    var hideMenuIcons = nsPreferences.getBoolPref("local_install.hideMenuIcons");
    var myItems = document.getElementsByAttribute("local_install", "true");
  
    var thisClassTypeMenuItem = (hideMenuIcons) ? "" : "menuitem-iconic"
    var thisClassTypeMenu = (hideMenuIcons) ? "" : "menu-iconic"

    for (i in myItems) {
      switch (myItems[i].nodeName) {
        case "menuitem":
          myItems[i].setAttribute("class", thisClassTypeMenuItem);
          break;
        case "menu":
          myItems[i].setAttribute("class", thisClassTypeMenu);
      }
    }
  },
  
  setThrobberClick: function() {
    var myThrobber = document.getElementById("navigator-throbber");
    if (nsPreferences.getBoolPref("local_install.useCustomThrobberClick") && myThrobber) {
      myThrobber.setAttribute("mousethrough", "never");
      myThrobber.setAttribute("disabled", "false");
      //myThrobber.setAttribute("oncommand", "Local_Install.openThrobber(false, event);");
      myThrobber.setAttribute("onclick", "Local_Install.checkForMiddleClick(this, event);");
      myThrobber.setAttribute("tooltiptext", local_common.getThrobberURL())
    } else if (myThrobber) {
      myThrobber.setAttribute("mousethrough", "always");
      myThrobber.setAttribute("disabled", "true")
      myThrobber.setAttribute("oncommand", "")
      myThrobber.setAttribute("onclick", "");
      myThrobber.setAttribute("tooltiptext", "")
    }
  },
  
  toggleInstallButton: function() {
    // Hide/show install button
    var hideInstallButton = nsPreferences.getBoolPref("local_install.extensions.hideInstallButton")
    var hideTheseButton = ['installButton', 'installNewTheme', 'installFileButton'];
    var buttonToHide
    var inAddonsInstall = false

    if (typeof gView != "undefined") {
      inAddonsInstall = (gView == "installs") ? true : false;
    }

    for (var b = 0; b < hideTheseButton.length; ++b) {
      buttonToHide = document.getElementById(hideTheseButton[b])
      if (buttonToHide && !inAddonsInstall) {
        buttonToHide.hidden = hideInstallButton;
      }
    } 
  },
	
	setExtensionCompatibility: function() {			
		//  3.7 trunk build changes
		var gBranchVersion = /^([^\.]+\.[^a-z\.]+[a-z]?).*/gi;
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
										 .getService(Components.interfaces.nsIXULAppInfo)
										 .QueryInterface(Components.interfaces.nsIXULRuntime);
		var appVersion = appInfo.version.replace(gBranchVersion, "$1");

		var branchService = Components.classes["@mozilla.org/preferences-service;1"]
													.getService(Components.interfaces.nsIPrefBranch);

		if (!branchService.prefHasUserValue("extensions.checkCompatibility." + appVersion)) {
			 //alert("You know this is dangerous....");
		}

		nsPreferences.setBoolPref("local_install.extensions.checkCompatibility", nsPreferences.getBoolPref("extensions.checkCompatibility"), true);

		nsPreferences.setBoolPref("extensions.checkCompatibility." + appVersion, nsPreferences.getBoolPref("extensions.checkCompatibility"), true);
	}

};

function myXPInstallDownloadManager() {
}

myXPInstallDownloadManager.prototype = {
  
  observe: function (aSubject, aTopic, aData) {
    switch (aTopic) {
      case "xpinstall-download-started":
        var myParams = aSubject.QueryInterface(Components.interfaces.nsISupportsArray);
        var myParamBlock = myParams.GetElementAt(0).QueryInterface(Components.interfaces.nsISupportsInterfacePointer);
        myParamBlock = myParamBlock.data.QueryInterface(Components.interfaces.nsIDialogParamBlock);
        this.addDownloads(myParamBlock);
        break;
    }
  },
  
  addDownloads: function (aParams) {
    if (nsPreferences.getBoolPref("local_install.setAutoArchive")) {

      var myLocalStrings = myLocalBundleService
            .createBundle("chrome://local_install/locale/local_install.properties");

      var numXPInstallItems = aParams.GetInt(1);

      for (var i = 0; i < numXPInstallItems;) {
        var displayName = aParams.GetString(i++);
 
        var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
        uri.spec = aParams.GetString(i++);
    
        var myDownloadURL = uri.spec;
        var thisDir = /\.xpi$/i.test(myDownloadURL) ? BASE_EXTENSION_DIR : BASE_THEME_DIR;
  
        var url = uri.QueryInterface(Components.interfaces.nsIURL);
    
        var myExtensionPath = local_common.getComplexPref(thisDir);
    
        if(!myExtensionPath.exists()) {
          try {
            myExtensionPath.create(0x01,0644);
          } catch(ex) {
            local_common.debug(ex);
          }
        }

        if (myDownloadURL.length > 0 && myExtensionPath.isDirectory() && uri.scheme != "file") {
          myExtensionPath.append(url.fileName);
          local_common.myListenerStartMsg = myLocalStrings.GetStringFromName("archivingAuto") + " " + url.fileName;
          local_common.myListenerEndMsg = myLocalStrings.GetStringFromName("archivingAutoFini");
          try {
            local_common.downloadFile(myDownloadURL, myExtensionPath.path);
          } catch(ex) {
          }
        }
  
        var iconURL = aParams.GetString(i++);
        var certName = aParams.GetString(i++);
      }
    }
  },
  
  removeDownload: function (aEvent){
  },
  
  onStateChange: function (aAddon, aState, aValue) {
    try {
      const nsIXPIProgressDialog = Components.interfaces.nsIXPIProgressDialog;

      switch (aState) {
        case nsIXPIProgressDialog.DOWNLOAD_START:
          Local_Install.archiveVault(aAddon.xpiURL);
          break;
        case nsIXPIProgressDialog.DOWNLOAD_DONE:
        case nsIXPIProgressDialog.INSTALL_START:
        case nsIXPIProgressDialog.INSTALL_DONE:
        case nsIXPIProgressDialog.DIALOG_CLOSE:
          break;
      }
    } catch (ex) {
      local_common.debug(ex);
    }
  },

  onDownloadProgress: function (aAddon, aValue, aMaxValue) {
    try {
      var percent = Math.round((aValue / aMaxValue) * 100);
      var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

      browserWindow.document.getElementById("statusbar-display").label = 
        myLocalStrings.GetStringFromName("archiving") + " " + aAddon.name + ": " + percent;
    } catch (ex) {
      local_common.debug(ex);
    }
  },

  onProgress: function (aAddon, aValue, aMaxValue) {
    try {
      var percent = Math.round((aValue / aMaxValue) * 100);
      var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

      browserWindow.document.getElementById("statusbar-display").label = 
        myLocalStrings.GetStringFromName("archiving") + " " + aAddon.name + ": " + percent;
    } catch (ex) {
      local_common.debug(ex);
    }
  },

  onDownloadStarted: function (aAddon) {
  },

  onDownloadEnded: function (aAddon) {
  },

  onInstallStarted: function (aAddon) {
  },

  onInstallEnded: function (aAddon, aStatus) {
  },

  onInstallsCompleted: function() {
  },
  
  getElementForAddon: function(aAddon) {
    var element = document.getElementById(PREFIX_ITEM_URI + aAddon.id);
    if (aAddon.id == aAddon.xpiURL)
      element = document.getElementById(aAddon.xpiURL);
    return element;
  },

  onCompatibilityCheckStarted: function(aAddon) {
  },
  
  onCompatibilityCheckEnded: function(aAddon, aStatus) {
  },

  _urls: { },

  QueryInterface: function (aIID) {
    if (!aIID.equals(Components.interfaces.nsIAddonUpdateListener) &&
        !aIID.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
}

var themeObserver = {
  observe: function(aSubject, aTopic, aData) {
    if (aTopic != "nsPref:changed") return;

    if (nsPreferences.getBoolPref("local_install.promptOnThemeChange")) {
      setTimeout(function() { local_common.restartPrompt(true); }, 250);
    }
  }
}

var throbberObserver = {
  observe: function(aSubject, aTopic, aData) {
    if (aTopic != "nsPref:changed") return;

    Local_Install.setThrobberClick();
  }
}

/* Check for call to open up the New Addons window in firefox||thunderbird*/
if (typeof BrowserOpenAddonsMgr == "function") { // firefox
  BrowserOpenAddonsMgr = function() { Local_Install.openManager(nsPreferences.copyUnicharPref('local_install.addons_view_override')) };
}

if (typeof openAddonsMgr == "function") { //thunderbird
  openAddonsMgr = function() { Local_Install.openManager(nsPreferences.copyUnicharPref('local_install.addons_view_override')) };
}

if (typeof goOpenAddons == "function") { //sunbird
  goOpenAddons = function() { Local_Install.openManager(nsPreferences.copyUnicharPref('local_install.addons_view_override')) };
}

/* Original override for built-in call to open em/tm window (from EM Buttons I added typeof error checking)*/
if (typeof BrowserOpenExtensions == "function") {
  BrowserOpenExtensions = Local_Install.openManager;
}

/* Work around for Firetitle or titletweak? */
if (typeof setTitleFromFolder == "function") {
  setTitleFromFolder = Local_Install.mySetTitleFromFolder;
}

/* Work around to get Update Notifier to archive downloads */
if (typeof UN_gOverlay == "object") {
  UN_gOverlay.installUpdates = Local_Install.myUN_InstallUpdates;
}

nsPreferences.setBoolPref("local_install.promptingToRestart", false);
nsPreferences.setBoolPref("local_install.promptingToAutoUninstall", false);

Local_Install.setExtensionCompatibility();

if (myBrandShortName != "Thunderbird") {
  window.addEventListener("load", function() { Local_Install.initTitleListener(); }, false);
} else {
  setTimeout(Local_Install.showAttachmentBox, 250);
}

window.addEventListener("load", function() { Local_Install.register(); } , false);
window.addEventListener("unload", function() { Local_Install.unregister(); } , false);
window.addEventListener("unload", function() { Local_Install.removeInstallerObserver(); } , false);
window.addEventListener("unload", function() { Local_Install.setMultiWindowTitleMode(); } , false);
