/* mrtech-common.js: version 1.6 - 2/13/2007 */

var myLocalBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"]
      .getService(Components.interfaces.nsIStringBundleService);

//var myOrigTitleModifier = null;

var local_common = {

  myListenerStartMsg: null,
  myListenerEndMsg: null,
  myFilePicker: Components.interfaces.nsIFilePicker,
  myLocalFile: Components.interfaces.nsILocalFile,
  mExtVersion: nsPreferences.copyUnicharPref("app.extensions.version"),
	buildID: null,
	appID: null,
	appVersion: null,
	mCRLF: null,

  init: function(){
    if (/(Windows)/.test(navigator.userAgent)) {
      this.mCRLF = "\r\n";
    } else if(/(Linux)/.test(navigator.userAgent)) {
      this.mCRLF = "\n";
    } else {
      this.mCRLF = "\r";
    }  

    this.buildID  = this.getBuildID();    
    this.appID    = this.getAppID();
    this.appVersion  = this.getAppVersion();    

    //myOrigTitleModifier = this.getOrigTitleModifier();
  },
  
  copyBuildID: function(inText) {
    this.copyToClipboard(inText + "Build ID: " + this.buildID);
  },

  copyToClipboard: function(inText) {
    var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"].
                                           getService(Components.interfaces.nsIClipboardHelper);
    clipboard.copyString(inText);
  },
  
  createBrandingBundle: function() {
    var myBrandingPath = null;
    var myStringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"]
                        .getService(Components.interfaces.nsIStringBundleService);
    
    myBrandingPath = "chrome://branding/locale/brand.properties"
    
    return myStringBundleService.createBundle(myBrandingPath);
  },

  downloadFile: function(thisFile, thisPath) {
    try {
      var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService).newURI(thisFile, null, null);
      var obj_TargetFile = Components.classes["@mozilla.org/file/local;1"]
                             .createInstance(Components.interfaces.nsILocalFile);
      obj_TargetFile.initWithPath(thisPath);
    
      if(!obj_TargetFile.exists()) {
        try {
          obj_TargetFile.create(0x00,0644);
        } catch(ex) {
          this.debug(ex);
        }
      }

      var obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                      .createInstance(Components.interfaces.nsIWebBrowserPersist);
    } catch (ex) {
      this.debug(ex);
    }
    
    obj_Persist.progressListener = local_common.myListener;
    obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile);
  },

  trim: function(aString) {
  	return aString.replace(/(^\s+)|(\s+$)/g, '');
  },

  debug: function() {
    var mConsoleService = Components.classes["@mozilla.org/consoleservice;1"]
           .getService(Components.interfaces.nsIConsoleService)
    mConsoleService.logStringMessage("MR Tech: " + Array.join(arguments, ": ") + "\n");
  },

  IsOldBrowser: function() {
    // 9/29/2005: update again for one liner
    return typeof Components.interfaces.nsIXULAppInfo == "undefined" ? true : false;
  },
    
  openSeasame: function(myLink, prefName) {
    // Open the manager in the prescribed manner, or toggle the sidebar
    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    if (myLink == "about:config" && browserWindow.document.getElementById("cmd_aboutconfig")) {
      if (local_common.noWindowTypeToFocus("global:aboutconfig")) {
        openDialog("chrome://aboutconfig/content/config.xul", "about:config", "dialog=no");
      }
      return true;
    }

    if (myLink == "about:kitchensink" && myBrandShortName == "Mozilla") {
      myLink = "https://bugzilla.mozilla.org/attachment.cgi?id=114919";
    }

    if (myLink == "about:plugins") {
      myLink = "chrome://local_install/content/plugins.html";
    }

    switch (myBrandShortName) {
      case "Songbird":
      case "Calendar":
      case "Sunbird":
      case "Thunderbird":
      case "eMusic Download Manager":
        if (myLink == "about:config") {
          openDialog("chrome://global/content/config.xul", "Preferences:ConfigManager", "chrome,titlebar,centerscreen,resizable,dialog=no");
        } else if (myLink.indexOf("http") == 0) {
            this.loadExternalURL(myLink);
        } else {
          openDialog(myLink, myLink, "dialog=no,titlebar,centerscreen,width=640,height=480,resizable");
        }
        return true;
    } 

    var openPref
    
    if (prefName == "forceTab") {
      openPref = 1
    } else {
      openPref = nsPreferences.getIntPref(prefName);
    }
    
    switch (openPref) {
      case 1:
        
        var aboutBlank = null;

        try {
          aboutBlank = browserWindow._content.location.href == "about:blank";
        } catch (ex) {
        }

        if (aboutBlank){
          browserWindow._content.location.href = myLink;
        } else {
          var thisWindow = browserWindow.getBrowser();
          var newTab = thisWindow.addTab(myLink, null, null);
          thisWindow.selectedTab = newTab;
        }
        break;
  
      case 2:
        browserWindow.open(myLink, "_blank", "menubar=yes,scrollbars=yes,resizable=yes,status=yes,centerscreen");
        break;
   
      default:
        try {
          browserWindow._content.location.href = myLink;
        } catch(ex) {
        }
    }

    return true;
  },
  
  openURL: function(myLink, forceTab, focusTab) {

    switch (myBrandShortName) {
      case "Thunderbird":
        if (local_common.thunderClick(myLink, forceTab)) {
          break;
        }
      case "Nvu":
      case "Calendar":
      case "Sunbird":
      case "eMusic Download Manager":
        this.loadExternalURL(myLink);
        break;
      //case "Mozilla":
      default:
        var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());
        
        try {
          var myWindowContent = browserWindow._content.location.href;
          if (myWindowContent == "about:blank") {
            forceTab = false
          }
        } catch (ex) {
        }

        if (forceTab == true){
          var thisBrowserWindow = browserWindow.getBrowser();
          var newTab = thisBrowserWindow.addTab(myLink, null, null);
          if (focusTab != false) {
            thisBrowserWindow.selectedTab = newTab;
          }
        } else {
          browserWindow._content.location.href = myLink;
        }
        break;
    }

  },
  
  variables: {
  	appid: null,
  	vendor: null,
  	name: null,
  	version: null,
  	appbuildid: null,
  	platformbuildid: null,
  	platformversion: null,
  	geckobuildid: null,
  	geckoversion: null,
  	brandname: null,
  	useragent: navigator.userAgent,
  	locale: null,
  	os: null,
  	processor: null,
  	compiler: null,
  	defaulttitle: null,
  	firesomething: null,
  	tabcount: null,
  	windowcount: null,
  	profile: null
  },

	inPrivateBrowsing: function() {
		try {
			if ("@mozilla.org/privatebrowsing;1" in Components.classes) {
				return Components.classes["@mozilla.org/privatebrowsing;1"].
					getService(Components.interfaces.nsIPrivateBrowsingService).
					privateBrowsingEnabled;
			} else {
				return false;
			}
		} catch (ex) {
			return false;
		}
	},
	
  populateSysVariables: function() {
    local_common.variables.defaulttitle     = local_common.getOrigTitleModifier();
		local_common.variables.appid            = local_common.appID;
		local_common.variables.vendor           = myVendorShortName;
		local_common.variables.name             = myBrandShortName;
		local_common.variables.brandname        = myBrandFullName;
		local_common.variables.appbuildid       = local_common.appID;
    local_common.variables.platformbuildid  = local_common.buildID;
		local_common.variables.version          = nsPreferences.copyUnicharPref('app.version');
		local_common.variables.geckobuildid     = local_common.variables.appbuildid;
		local_common.variables.firesomething    = local_common.getFiresomethingTitle();

    var tabCount = 0

    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType())
    if (browserWindow) {
      try {
        var browserTabContainer = browserWindow.getBrowser().mTabContainer;
        tabCount = browserTabContainer.childNodes.length;
      } catch (ex) {
      }
    }

		local_common.variables.tabcount = tabCount.toString();

    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var browserEnumerator = wm.getEnumerator(local_common.getWindowType());

    var winCount = 0
    while (browserEnumerator.hasMoreElements()) { 
      browserEnumerator.getNext();
      winCount++
    }

		local_common.variables.windowcount = winCount.toString();

  	if ((Components.classes['@mozilla.org/xre/app-info;1']) && (Components.interfaces.nsIXULAppInfo)) {

  		var appinfo = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo);

  		local_common.variables.version     = appinfo.version;
  		
  		if (appinfo.platformBuildID) {
  			local_common.variables.platformbuildid  = appinfo.platformBuildID;
  			local_common.variables.platformversion  = appinfo.platformVersion;
  			local_common.variables.geckobuildid     = appinfo.platformBuildID;
  		} else {
  			local_common.variables.geckobuildid     = appinfo.geckoBuildID;
  		}
  		
  		local_common.variables.profile = local_common.getProfileName();
  		
  		if (Components.interfaces.nsIXULRuntime) {
    		appinfo=appinfo.QueryInterface(Components.interfaces.nsIXULRuntime);
    		local_common.variables.os         = appinfo.OS;

    		var bits=appinfo.XPCOMABI.split("-");
    		local_common.variables.processor  = bits[0];
    		local_common.variables.compiler   = bits[1];
  		}
  	}

    try {
      local_common.variables.locale = local_common.getComplexPref("general.useragent.locale",
                          Components.interfaces.nsIPrefLocalizedString).data;
    } catch (e) {
      local_common.variables.locale = nsPreferences.copyUnicharPref("general.useragent.locale");
    }

  	var ua = local_common.variables.useragent;
  	ua = ua.substring(ua.indexOf("rv:")+3, ua.indexOf(")"));
  	local_common.variables.geckoversion = ua;
  
  	if (!local_common.variables.platformversion) {
  		local_common.variables.platformversion = local_common.variables.geckoversion;
  	}
 
  },

  generateText: function(template) {
    if (template == null) { return "" }
  	var start=0;
  	var pos = template.indexOf("${",start);
  	while (pos>=0) {
  		if ((pos==0)||(template.charAt(pos-1)!="$")) {
  			var endpos = template.indexOf("}",pos+2);
  			if (endpos>=0) {
  				var varname = template.substring(pos+2,endpos);
  				var varvalue = local_common.getSysVariable(varname);
//  				local_common.debug(varname, varvalue);
  				if (varvalue) {
  					template=template.substring(0,pos)+varvalue+template.substring(endpos+1,template.length);
  					start=pos+varvalue.length;
  				} else {
  					start=pos+2;
  				}
  			} else {
  				start=pos+2;
  			}
  		} else {
  			start=pos+2;
  		}
  		pos=template.indexOf("${",start);
  	}
  	return template;
  },
  
  getFiresomethingTitle: function() {
    var myWindow = local_common.mostRecentWindow(local_common.getWindowType());

    if (typeof myWindow.FireSomething == "object") { 
  /*		var vendor = myWindow.FireSomething.getRandomName("firesomething.lists.vendors");
  		var spacer = myWindow.FireSomething.getRandomName("firesomething.lists.spacers");
  		var prefix = myWindow.FireSomething.getRandomName("firesomething.lists.prefixes");
  		var suffix = myWindow.FireSomething.getRandomName("firesomething.lists.names");
  		var comment = myWindow.FireSomething.getRandomName("firesomething.lists.comments");
  */
      return myWindow.FireSomething.Vendor + myWindow.FireSomething.ShortName + myWindow.FireSomething.TitleComment;
    } else {
      return local_common.getOrigTitleModifier();
    }
  },

  getSysVariable: function(thisValue) {
  	thisValue    = thisValue.toLowerCase();
    var varvalue = "";
    var thisType = "variables";
    
 		varvalue = local_common[thisType][thisValue];

    return varvalue;
  },

  getBuildID: function() {

    var tmpBuild = null;

    tmpBuild = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo).appBuildID;
    
    return tmpBuild;
  },

  getAppID: function() {

    var tmpAppID = null;

    tmpAppID = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo).ID;
    
    return tmpAppID;
  },

  getAppVersion: function() {

    var tmpAppVersion = null;

    tmpAppVersion = Components.classes['@mozilla.org/xre/app-info;1'].getService(Components.interfaces.nsIXULAppInfo).version;

    return tmpAppVersion;
  },

  getOrigTitleModifier: function() {

    //var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
    //                   .getService(Components.interfaces.nsIWindowMediator);
    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    var myBrandStrings = local_common.createBrandingBundle();

    if (myBrandStrings.GetStringFromName("brandShortName") == "Mozilla Thunderbird" || myBrandStrings.GetStringFromName("brandShortName") == "Shredder") {
      return myBrandStrings.GetStringFromName("brandShortName");
    }
    
    if (!browserWindow) {
       return null;
    }
    
    var myModifier

		if (!local_common.inPrivateBrowsing()) {
			myModifier = "titlemodifier_normal";
		} else {
			myModifier = "titlemodifier_privatebrowsing";
		}

    var docElement = browserWindow.document.documentElement.getAttribute(myModifier);
		
		if (!docElement) {
			myModifier = "titlemodifier";
			docElement = browserWindow.document.documentElement.getAttribute(myModifier);
		}
   
		// if (docElement && (browserWindow.myOrigTitleModifier == null || browserWindow.myOrigTitleModifier == "undefined")) {
      return docElement;
    // } else {
      // return browserWindow.myOrigTitleModifier;
    // }

    //return null;
  },

  filter: function(l,f) {
      var r = [];

      if (!f) f = function(v){return v};
      for (var i=0; i<l.length; i++) if (f(l[i])) r.push(l[i]);

      return r;
  },

  loadExternalURL: function(url) {
    if (url) {
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
      var uri = ioService.newURI(url, null, null);
      var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                                     .getService(Components.interfaces.nsIExternalProtocolService);
  
      extProtocolSvc.loadUrl(uri);
    }
  },

  myListener: {
    STATE_STOP: Components.interfaces.nsIWebProgressListener.STATE_STOP,
    STATE_START: Components.interfaces.nsIWebProgressListener.STATE_START,
    STATE_TRANSFERRING: Components.interfaces.nsIWebProgressListener.STATE_TRANSFERRING,

    QueryInterface : function(aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
        return this;
      throw Components.results.NS_NOINTERFACE;
    },
  
    onStateChange:function(aProgress,aRequest,aFlag,aStatus) {
      if (typeof local_common != "function") { return }

      var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

      if(aFlag & this.STATE_START) {
        try {
          browserWindow.document.getElementById("statusbar-display").label = local_common.myListenerStartMsg;
        } catch(ex) {
        }
      }
      if(aFlag & this.STATE_STOP) {
        try {
          browserWindow.document.getElementById("statusbar-display").label = local_common.myListenerEndMsg;
        } catch(ex) {
        }
      }
    },

    onLocationChange:function(a,b,c){},

    onProgressChange:function(a,b,c,d,e,f){
      //local_common.debug(a + ":" + b + ":" + c + ":" + d + ":" + e + ":" + f);
      if(this.STATE_TRANSFERRING) {
        try {
          var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

          browserWindow.document.getElementById("statusbar-display").label = 
            local_common.myListenerStartMsg + ": " + Math.ceil((e/f) * 100);

        } catch(ex) {
        }
      }
    },

    onStatusChange:function(a,b,c,d){},

    onSecurityChange:function(a,b,c){},

    onLinkIconAvailable:function(a){}
  },
 
  linkURI: function() {
  /*return (gContextMenu.onSaveableLink) ? gContextMenu.linkURL() :
  (gContextMenu.onImage) ? gContextMenu.imageURL() :
  null;
  */
    return (local_common.onLink()) ? local_common.getContextMenuLinkURL() : null;
  },

  getContextMenuLinkURL: function() {
    if (!gContextMenu.linkURL.length) {
      return(gContextMenu.linkURL());
    } else {
      return(gContextMenu.linkURL);
    }
  },
  
  onLink: function() {
    return (gContextMenu.onSaveableLink);
  },

  onImage: function() {
    return (gContextMenu.onImage);
  },
  
  noWindowTypeToFocus: function(windowType) {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
    var myWindows = wm.getEnumerator(windowType);

    while (myWindows.hasMoreElements()) {
      var myConfigWindow = myWindows.getNext().QueryInterface(Components.interfaces.nsIDOMWindowInternal);
      if (myConfigWindow.document.documentElement.getAttribute("windowtype") == windowType) {
         try {
           myConfigWindow.focus();
         } catch (ex) {
         }
         return false;
      }
    }
    
    return true;
  },
  
  mostRecentWindow: function(windowType) {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    return wm.getMostRecentWindow(windowType);
  },
  
  restartPrompt: function(promptMe){

    //  promptingToRestart is used to avoid multiple windows from prompting to restart
    if (nsPreferences.getBoolPref("local_install.promptingToRestart")) {
      return true;
    }

    if (promptMe != false) {
      nsPreferences.setBoolPref("local_install.promptingToRestart", true);

      var myPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
  
      var myLocalStrings = myLocalBundleService
            .createBundle("chrome://local_install/locale/local_install.properties");
  
      var retVal  = myPrompts.confirm(window, myLocalStrings.GetStringFromName("appName"), 
                                          myLocalStrings.GetStringFromName("promptRestart"));
  
      if (!retVal) {
         nsPreferences.setBoolPref("local_install.promptingToRestart", false);
         return true;
      }
    }

    nsPreferences.setBoolPref("local_install.promptingToRestart", false);

    // Notify all windows that an application quit has been requested.
    var os = Components.classes["@mozilla.org/observer-service;1"]
                     .getService(Components.interfaces.nsIObserverService);
    var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
                              .createInstance(Components.interfaces.nsISupportsPRBool);
    os.notifyObservers(cancelQuit, "quit-application-requested", "restart");

    // Something aborted the quit process.
    if (cancelQuit.data)
     return false;

    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
    var windows = wm.getEnumerator("");

    var windowType = local_common.getWindowType();

    while (windows.hasMoreElements()) {
      var myConfigWindow = windows.getNext().QueryInterface(Components.interfaces.nsIDOMWindowInternal);
      if (myConfigWindow.document.documentElement.getAttribute("windowtype") != windowType) {
         myConfigWindow.close();
      }
    }

    if ("@zeniko/crashrecoveryservice;1" in Components.classes && 
      nsPreferences.getBoolPref("local_install.enableSessionManagerResume")) {
      nsPreferences.setBoolPref("extensions.crashrecovery.resume_session_once", true);
    }

    var appStartup = Components.interfaces.nsIAppStartup;
    Components.classes["@mozilla.org/toolkit/app-startup;1"]
      .getService(appStartup).quit(appStartup.eRestart | appStartup.eAttemptQuit);

    return true;

  },

  getWindowType: function() {
    // Relies on Branding Code so can not be run on startup
    var myBrandStrings = local_common.createBrandingBundle();

    var thisBrandShortName = myBrandStrings.GetStringFromName("brandShortName")

    switch (thisBrandShortName) {
      case "Mozilla Thunderbird":
      case "Shredder":
      case "Thunderbird":
        return "mail:3pane";
      case "Nvu":
        return "composer:html";
      case "Calendar":
      case "Sunbird":
        return "calendarMainWindow";
      case "eMusic Download Manager":
      case "eMusic Remote":
        return "emusic:window";
      case "Songbird":
        return "Songbird:Main";
      default:
        return "navigator:browser";
    }
  },

  getURLSpecFromFile: function (file) {
    var ioServ = Components.classes["@mozilla.org/network/io-service;1"]
                   .getService(Components.interfaces.nsIIOService);
    var fph = ioServ.getProtocolHandler("file")
                .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    return fph.getURLSpecFromFile(file);
  },

	getLocalFileInterface: function(filePath) {
		try {
			var localFileInterface = Components.classes["@mozilla.org/file/local;1"].createInstance(local_common.myLocalFile);
			localFileInterface.initWithPath(filePath);
			return localFileInterface;
		} catch (ex) {
			return null;
		}
	},

  getSpecialFolder: function(aFolderType) {
    // http://lxr.mozilla.org/mozilla/source/xpcom/io/nsAppDirectoryServiceDefs.h
    // http://lxr.mozilla.org/mozilla/source/xpcom/io/nsDirectoryServiceDefs.h
    // Returns object not string path
		var directoryService = Components.classes['@mozilla.org/file/directory_service;1']
                             .getService(Components.interfaces.nsIProperties);

		var thisDirectory = directoryService.get(aFolderType, Components.interfaces.nsIFile);
		
		//return thisDirectory.QueryInterface(Components.interfaces.nsILocalFile).path;
		return thisDirectory;
  },

  getSpecialFolderPath: function(aFolder) {
		return local_common.getSpecialFolder(aFolder).path;
  },

	openDirectory: function(directory) {
    var iDirectory = this.getLocalFileInterface(directory);
	  try {
      //iDirectory.launch();
		  iDirectory.reveal();
		} catch (ex) {
      //local_common.loadExternalURL(directory);

      // if reveal failed for some reason (eg on unix it's not currently
      // implemented), send the file: URL to the OS handler for that protocol
      var uri = Components.classes["@mozilla.org/network/io-service;1"]
                          .getService(Components.interfaces.nsIIOService)
                          .newFileURI(iDirectory);
      var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                                  .getService(Components.interfaces.nsIExternalProtocolService);
      protocolSvc.loadUrl(uri);

    }
	},

	openSpecialFolder: function(aFolderType) {
    if (!aFolderType) {
       aFolderType = 'ProfD';
    }

    var extDir = local_common.getSpecialFolderPath(aFolderType);

    local_common.openDirectory(extDir)
	},
  
  getComplexPref: function(pref, ojbType) {
    var prefs = nsPreferences.mPrefService;

    if (!ojbType) {
      ojbType = local_common.myLocalFile;
    }
  
    return prefs.getComplexValue(pref, ojbType)  
  },
  
  setComplexPref: function(pref, ojbType, thisData) {
    var prefs = nsPreferences.mPrefService;

    if (!ojbType) {
      ojbType = local_common.myLocalFile;
    }
  
    return prefs.setComplexValue(pref, ojbType, thisData)
  },
  
  flushPreferences: function() {
    /* Make sure preferences are saved */
    Components.classes["@mozilla.org/preferences-service;1"]
              .getService(Components.interfaces.nsIPrefService)
              .savePrefFile(null);
  },
  
  getProfileRegistry: function() {

  	var directoryService = Components.classes["@mozilla.org/file/directory_service;1"]
  										               .getService(Components.interfaces.nsIProperties);
  
    try {
    	var dir = directoryService.get("DefProfRt",Components.interfaces.nsIFile);
    	while (dir) {
  
    		var myFile = dir.clone();
    		myFile.append("profiles.ini");
  
    		if (myFile.exists()) {
    			return myFile;
    		}
  
    		dir = dir.parent;
    	}
    } catch(ex) {
    }
  	return null;
  },

  getProfileName: function() {
  	var name = "";
  	
  	var reg = local_common.getProfileRegistry();

  	if (!reg) {
  		return name;
  	}
  	
  	var directoryService = Components.classes["@mozilla.org/file/directory_service;1"]
  										               .getService(Components.interfaces.nsIProperties);
  	var profd = directoryService.get("ProfD", Components.interfaces.nsIFile);
  	
  	var stream = Components.classes["@mozilla.org/network/file-input-stream;1"]
  	                       .createInstance(Components.interfaces.nsIFileInputStream);
  	stream.init(reg, 1, 0, 0);
  	stream.QueryInterface(Components.interfaces.nsILineInputStream);
  	
  	var dir = Components.classes["@mozilla.org/file/local;1"]
  	                    .createInstance(Components.interfaces.nsILocalFile);
  	var current = "";
  	var relative = "d";
  	var line = {};
  	var path = "";

  	while (stream.readLine(line)) {
  		if (line.value.substring(0,5)=="Name=") {
  			current = line.value.substring(5);
  		}

  		if (line.value.substring(0,11)=="IsRelative=") {
  			relative = line.value.substring(11);
  		}

  		if (line.value.substring(0,5)=="Path=") {
  			path = line.value.substring(5);

  			if (relative=="1") {
  				dir.setRelativeDescriptor(reg.parent, path);
  			} else {
  				dir.persistentDescriptor = path;
  			}

  			if (dir.path==profd.path) {
  				name=current;
  				break;
  			}
  		}
  	}
  	
  	stream.close();
  	return name;
  },
  
  convertUnicodeToUTF8: function (thisStr) {
  	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
  	                  .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

  	converter.charset = "UTF-8";

  	var thisUTF = converter.ConvertFromUnicode(thisStr);

  	var fin = converter.Finish();

  	if(fin.length > 0) {
  		return thisUTF + fin;
  	} else {
  		return thisUTF;
  	}
  },
  
  getBranchPrefInterface: function (thisBranch) {
    if (typeof Components.interfaces.nsIPrefBranch2 == "undefined") {
      return thisBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal); //1.0.x support
    } else {
      return thisBranch.QueryInterface(Components.interfaces.nsIPrefBranch2); // 1.5+ support
    }
  },
  
  getThrobberURL: function() {
    var myThrobberPref = null;
    var myThrobberURL = null;
    
    switch (myBrandShortName) {
      case "Thunderbird":
        myThrobberPref = "messenger.throbber.url"
        break;
      case "Nvu":
        myThrobberPref = "editor.throbber.url"
        break;
      case "Mozilla":
      case "SeaMonkey":
      default:
        myThrobberPref = "browser.throbber.url"
    }

    try {
      if (myBrandShortName == "Nvu") {
        try {
          var myEditorBundle = nsPreferences.copyUnicharPref(myThrobberPref);
          var myLocalStrings = myLocalBundleService.createBundle(myEditorBundle);
          myThrobberURL = myLocalStrings.GetStringFromName("editor.site.url");
        } catch(ex) {
        }
        if (!myThrobberURL) {
          myThrobberURL = nsPreferences.copyUnicharPref(myThrobberPref);
        }
      } else {
        try {
          myThrobberURL = local_common.getComplexPref(myThrobberPref, Components.interfaces.nsIPrefLocalizedString).data;
        } catch(ex) {
          myThrobberURL = nsPreferences.copyUnicharPref(myThrobberPref);
        }
      }
    } catch(ex) {
    }

    if (!myThrobberURL) {
      myThrobberURL = "http://www.mozilla.org/";
    }

    return myThrobberURL;
  },
  
  insertCustomCSS: function(thisCSS, thisToggle) {
    // http://developer.mozilla.org/en/docs/Using_the_Stylesheet_Service

    if (thisToggle && Components.ID('{41d979dc-ea03-4235-86ff-1e3c090c5630}')
                 .equals(Components.interfaces.nsIStyleSheetService)) {
      var custCSS = document.createElementNS('http://www.w3.org/1999/xhtml', 'link');
      custCSS.setAttribute('rel', 'stylesheet');
      custCSS.setAttribute('href', thisCSS);
      custCSS.setAttribute('type', 'text/css');

      document.documentElement.appendChild(custCSS);
    } else {
      var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                  .getService(Components.interfaces.nsIStyleSheetService);

      var ios = Components.classes["@mozilla.org/network/io-service;1"]
                  .getService(Components.interfaces.nsIIOService);
      var uri = ios.newURI(thisCSS, null, null);

      if (thisToggle) {
        if(!sss.sheetRegistered(uri, sss.USER_SHEET)) {
          sss.loadAndRegisterSheet(uri, sss.USER_SHEET);
        }
      } else {
        if (sss.sheetRegistered(uri, sss.USER_SHEET)) {
          sss.unregisterSheet(uri, sss.USER_SHEET);
        }
      }
    }

  },

  isThunderBrowser: function() {
    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    var messagebox = browserWindow.document.getElementById("messagepanebox")

    if (!messagebox) return false

    return messagebox.hasAttribute("thunderbrowse")
  },

  thunderClick: function(thisURL, newTab) {
    var browserWindow = local_common.mostRecentWindow(local_common.getWindowType());

    if (local_common.isThunderBrowser()) {
      if (!newTab) {
        browserWindow.browsetothrufield(thisURL);
      } else {
        browserWindow.ThunderTabBrowser.addTab(thisURL);
      }
      return true;
    }

    return false;
  }
}

local_common.init();
