var open_profile = {

  fileRunOrOpen: function(thisPath, thisfile, thisPref, force) {

    var thisApp = nsPreferences.copyUnicharPref(thisPref);

    if (!thisApp && force) {
      nsPreferences.setIntPref('local_install.selected_settings_tab', 3);
      nsPreferences.setIntPref('local_install.selected_settings_sub_tab4', 4); 
      Local_Install.openSettings(null, 'myconfig_prefpane');
      thisApp = nsPreferences.copyUnicharPref(thisPref)
    }

    if (thisApp || force) {
      thisApp = local_common.getLocalFileInterface(thisApp);
      var myFile = local_common.getLocalFileInterface(thisPath);
      myFile.append(thisfile)

      open_profile.checkIfExists(myFile, thisfile);

      if (thisApp && myFile) {
        open_profile.openFile(thisApp, myFile)
      }
    } else {
      open_profile.runApplication(thisPath, thisfile)
    }

  },

  openFile: function(thisPath, thisFile) {
  
    var iMIMEService = Components.classes["@mozilla.org/uriloader/external-helper-app-service;1"]
                         .getService(Components.interfaces.nsIMIMEService);
    var iMIMEInfo = iMIMEService.getFromTypeAndExtension(thisFile, null);

    iMIMEInfo.alwaysAskBeforeHandling = false;
    iMIMEInfo.preferredAction = Components.interfaces.nsIMIMEInfo.useHelperApp;

    try {
      iMIMEInfo.preferredApplicationHandler = thisPath;
    } catch (ex) {
      var result = Components.classes["@mozilla.org/uriloader/local-handler-app;1"]
                     .createInstance(Components.interfaces.nsILocalHandlerApp);
      result.executable = thisPath;

      iMIMEInfo.preferredApplicationHandler = result;
    }

    iMIMEInfo.launchWithFile(thisFile);

  },

  runApplication: function(aFolder, aFile) {
    var fileLocal = Components.classes["@mozilla.org/file/local;1"]
                      .getService(Components.interfaces.nsILocalFile);

    if (aFolder) {
      fileLocal.initWithPath(aFolder);

      if (aFile) {
        fileLocal.append(aFile);
        open_profile.checkIfExists(fileLocal, aFile);
      }

      fileLocal.launch();
    }
  },

  checkIfExists: function(thisFile, fileName){
      if (!thisFile.exists()) {
        //alert( "Creating file... " );
        thisFile.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );

        var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
          .createInstance( Components.interfaces.nsIFileOutputStream );
        /* Open flags 
        #define PR_RDONLY       0x01
        #define PR_WRONLY       0x02
        #define PR_RDWR         0x04
        #define PR_CREATE_FILE  0x08
        #define PR_APPEND      0x10
        #define PR_TRUNCATE     0x20
        #define PR_SYNC         0x40
        #define PR_EXCL         0x80
        */
        /*
        ** File modes ....
        **
        ** CAVEAT: 'mode' is currently only applicable on UNIX platforms.
        ** The 'mode' argument may be ignored by PR_Open on other platforms.
        **
        **   00400   Read by owner.
        **   00200   Write by owner.
        **   00100   Execute (search if a directory) by owner.
        **   00040   Read by group.
        **   00020   Write by group.
        **   00010   Execute by group.
        **   00004   Read by others.
        **   00002   Write by others
        **   00001   Execute by others.
        **
        */
        outputStream.init( thisFile, 0x04 | 0x08 | 0x20, 420, 0 );
        var output = local_common.mCRLF

        if (fileName == "userChrome.css") {
          output += "@namespace url(\"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul\");" 
          output += local_common.mCRLF + local_common.mCRLF;
        }

        var result = outputStream.write( output, output.length );
        outputStream.close();
      }
  }

}
